<?php
include 'Functions.php';

header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');

$data=json_decode(file_get_contents("php://input"),true);
$header = apache_request_headers(); 

if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
  send_response($message);
  exit;  

}

$userID=$TokenExist[0]['userID'];
// $otherUserID=$data['otherUserID'];
$id=$data['id'];
$type=$data['type'];
$created=time();


if($type==1)
{
  $getFavUser = getDataFromTable('favusers','*',['favID'=>$id],'')[0];
  if (!$getFavUser) {
    http_response_code(200);
    $message =array('code'=>200,"status"=>1,"message"=>"Friend request not found.");
    send_response($message);
    exit; 
  }

  if ($getFavUser['status']==2) {
    http_response_code(200);
    $message =array('code'=>200,"status"=>1,"message"=>"Already accepted friend request.");
    send_response($message);
    exit; 
  }

  $update=updateDataTable('favusers',['favID'=>$id],['status'=>2]);


  if($update)
  {
    $getFavOtherUser = getDataFromTable('favusers','*',['userID'=>$getFavUser['otherUserID'],'otherUserID'=>$getFavUser['userID']],'')[0];
    if ($getFavOtherUser) {

     $update=updateDataTable('favusers',['userID'=>$getFavUser['otherUserID'],'otherUserID'=>$getFavUser['userID']],['status'=>2]);
    }else{
      $insert=insertDataTable('favusers',['userID'=>$getFavUser['otherUserID'],'otherUserID'=>$getFavUser['userID'], 'status'=>2,'created'=>$created]);
    }

    $getNotification=getDataFromTable('notification','*',['userID'=>$userID,'notificationType'=>1,'detailsID'=>$id],'')[0];
    $getNotification['notificationType']=6;
    
    $userDetails=getDataFromTable('users','*',['userID'=>$getNotification['userID']],'')[0];

    $notificationMessage = $userDetails['userName'];
    $message= "Accepted your request";

    $notificationUser = getDataFromTable('usertoken','*',['userID'=>$getNotification['otherUserID']],'');

    foreach ($notificationUser as $key1 => $valueUser) {
      if($valueUser['deviceType'] == 1) {
        $push_notification = sendpush_android($notificationMessage,$message, $valueUser['deviceToken'], $getNotification);
      }
      if($valueUser['deviceType'] == 2) {
        $push_notification = send_push_IOS_By_p8($notificationMessage,$message,$valueUser['deviceToken'],$getNotification,0);
      }
    }
  
    $deleteNotification = deleteDataTable('notification',['userID'=>$userID,'notificationType'=>1,'detailsID'=>$id]);
    $deleteNotification = deleteDataTable('notification',['userID'=>$getFavUser['userID'],'otherUserID'=>$getFavUser['otherUserID'],'notificationType'=>1]);

    // $updateNotification=updateDataTable('notification',['userID'=>$userID,'notificationType'=>1,'detailsID'=>$id],['status'=>0,'description'=>'Starting following you ','title'=>$name]);

    http_response_code(200);
    $message =array('code'=>200,"status"=>1,"message"=>"Accepted friend request.");
    send_response($message);
    exit; 
  }
  else
  {
    http_response_code(400);
    $message = array('code'=>400,"status" => 0, "message" => "Something went wrong");
    send_response($message);
  }
}
if($type==2)
{
  $getFavUser = getDataFromTable('favusers','*',['favID'=>$id],'')[0];
  if (!$getFavUser) {
    http_response_code(200);
    $message =array('code'=>200,"status"=>1,"message"=>"Friend request   found.");
    send_response($message);
    exit; 
  }

  $delete = deleteDataTable('favusers',['favID'=>$id]);
  $delete = deleteDataTable('favusers',['userID'=>$getFavUser['otherUserID'], 'otherUserID'=>$getFavUser['userID']]);
  $deleteNotification = deleteDataTable('notification',['userID'=>$userID,'notificationType'=>1,'detailsID'=>$id]);
  if($delete)
  {
    http_response_code(200);
    $message =array('code'=>200,"status"=>1,"message"=>"Rejected friend request.");
    send_response($message);
    exit; 
  }
  else
  {
    http_response_code(400);
    $message = array('code'=>400,"status" => 0, "message" => "Something went wrong");
    send_response($message);
  }
}
if($type==3)
{
  $getLobbyUser = getDataFromTable('lobbyusers','*',['id'=>$id],'')[0];
  if (!$getLobbyUser) {
    http_response_code(200);
    $message =array('code'=>200,"status"=>1,"message"=>"Joining request not found.");
    send_response($message);
    exit; 
  }

  if ($getLobbyUser['isApproved']==2) {
    http_response_code(200);
    $message =array('code'=>200,"status"=>1,"message"=>"Already accepted joining request.");
    send_response($message);
    exit; 
  }

  $update=updateDataTable('lobbyusers',['id'=>$id],['isApproved'=>2]);
  if($update)
  {
    $getDetail=getuserDataFromTablebyId('lobbyusers','*',['id'=>$id],'')[0];
    $getDetail['notificationType']=8;
    $lobbyUser=getDataFromTable('lobbies','*',['lobbyID'=>$getDetail['lobbyID']],'')[0];

    $userDetails=getDataFromTable('users','*',['userID'=>$lobbyUser['userID']],'')[0];

    $notificationMessage = $userDetails['userName'];
    $message= "Accepted joining request";
    // $getNotification=getuserDataFromTablebyId('lobbyusers','*',['id'=>$id],'')[0];
    $notificationUser = getDataFromTable('usertoken','*',['userID'=>$getDetail['userID']],'');

    foreach ($notificationUser as $key1 => $valueUser) {
      if($valueUser['deviceType'] == 1) {
        $push_notification = sendpush_android($notificationMessage,$message, $valueUser['deviceToken'], $getDetail);
      }
      if($valueUser['deviceType'] == 2) {
        $push_notification = send_push_IOS_By_p8($notificationMessage,$message,$valueUser['deviceToken'],$getDetail,0);
      }
    }
    
    http_response_code(200);
    $message =array('code'=>200,"status"=>1,"message"=>"Accepted joining request successfully.");
    send_response($message);
    exit; 
  }
  else
  {
    http_response_code(400);
    $message = array('code'=>400,"status" => 0, "message" => "Something went wrong");
    send_response($message);
  }
}
if($type==4)
{
  $getLobbyUser = getDataFromTable('lobbyusers','*',['id'=>$id],'')[0];
  if (!$getLobbyUser) {
    http_response_code(200);
    $message =array('code'=>200,"status"=>1,"message"=>"Joining request not found.");
    send_response($message);
    exit; 
  }

  $delete = deleteDataTable('lobbyusers',['id'=>$id]);
  if($delete)
  {
    http_response_code(200);
    $message =array('code'=>200,"status"=>1,"message"=>"Rejected joining request successfully.");
    send_response($message);
    exit; 
  }
  else
  {
    http_response_code(400);
    $message = array('code'=>400,"status" => 0, "message" => "Something went wrong");
    send_response($message);
  }
}

?>