<?php
include 'Functions.php';

header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');
$data=json_decode(file_get_contents("php://input"),true);
$header = apache_request_headers(); 

if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
	http_response_code(401);
	$message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
	send_response($message);
	exit;  

}


$userID=$TokenExist[0]['userID'];
$type=$_POST['type'];    // 1=>Add venue image, 2=>Delete venue image
$venueImageID=$_POST['venueImageID'];
$venueID=$_POST['venueID'];
$venueImage=$_FILES['venueImage'];
$created=time();
$venueDir='venue/venueImage/';


if(!$type)
{
http_response_code(400);
$message = array('code'=>400,'status'=>0,'message'=>"Parameters missing.");
send_response($message);
exit;
 
}


if($type==1)
{

	if (!empty($_FILES['venueImage']['name'])) 
	{

	   if(!is_dir($venueDir))
	   {

	    	mkdir($venueDir);
	   }
	           
	$uniquesavename=time().'_'.uniqid().'.'.strtolower(pathinfo($_FILES['venueImage']['name'],PATHINFO_EXTENSION ));
	$targetFile = $venueDir . $uniquesavename;
	$file_tmp= $_FILES['venueImage']['tmp_name'];

	move_uploaded_file($file_tmp, $targetFile);
	  
	$insert=insertDataTable('venueimage',['venueImage'=>$uniquesavename,'userID'=>$userID,'venueID'=>$venueID,'created'=>$created]);

	}

	$imgDetail=getVenueImagesListing($userID,$venueID);


	http_response_code(200);
	$message =array('code'=>200,'status'=>1,'message'=>'Image added successfully','data'=>$imgDetail);
	send_response($message);
	exit; 


}

if($type==2)
{

	$get_data =getDataFromTable('venueimage','*',['id'=>$venueImageID],'');

	$delete=deleteDataTable('venueimage',['id'=>$venueImageID]);

	if($delete)
	{
		$imgDetail=getVenueImagesListing($userID,$venueID);

		unlink($get_data[0]['venueImage']);
		http_response_code(200);
		$message =array('code'=>200,"status"=>1,"message"=>"Image deleted successfully",'data'=>$imgDetail);
		send_response($message);
		exit; 
	          	 
	}else
	{
		http_response_code(400);
		$message =array('code'=>400,"status"=>0,"message"=>"something wents wrong");
		send_response($message);
		exit;
	}
	
}



  function getVenueImagesListing($userID,$venueID)
  {

    global $con;
    global $config;
    $array=array();
    if(!empty($venueID))
    {
    	 $query="SELECT * FROM venueimage WHERE venueID=$venueID AND userID=$userID AND disable=0 ORDER BY id DESC";
    }else
    {

    	$query="SELECT * FROM venueimage WHERE venueID=0 AND userID=$userID AND disable=0 ORDER BY id DESC";
	}
    // print_r($query);die();
    $run = $con->query($query);
    while($result = $run->fetch_assoc())
      {

          if (!empty($result['venueImage'])) {
             

          $result['venueImage']=$config['base_url'].'venue/venueImage/'.$result['venueImage'];


          }
          else
          {
              $result['venueImage']="";
          }         
          array_push($array, $result);
      }

        return $array;

  }

?>