<?php
include 'Functions.php';
header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');

// $data=json_decode(file_get_contents("php://input"),true);

$header = apache_request_headers(); 
if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
  send_response($message);
  exit;  

}

$userID=$TokenExist[0]['userID'];

$eventID=$_POST['eventID'];
$eventName=$_POST['eventName'];
$categoryID=$_POST['categoryID'];
$eventDescription=$_POST['eventDescription'];
$date=$_POST['date'];
$eventType=$_POST['eventType'];
$time=$_POST['time'];
$dateAndTime=$_POST['dateAndTime'];
$latitude=$_POST['latitude'];
$longitude=$_POST['longitude'];
$location=$_POST['location'];
$forAdults=$_POST['forAdults'];
$eventCost=$_POST['eventCost'];
$numberOfUsers=$_POST['numberOfUsers'];
$parkingCost=$_POST['parkingCost'];
$hostName=$_POST['hostName'];
$djName=$_POST['djName'];
$artistName=$_POST['artistName'];
$eventImage=$_FILES['eventImage'];
$hostImage=$_FILES['hostImage'];
$created=time();
$folderName='eventImage/';
$folderName1='hostImage/';
$folderName2='djImage/';
$folderName3='artistImage/';


if(!$eventName || !$categoryID || !$eventDescription || !$date || !$time  || !$latitude || !$longitude || !$location || !$hostName || !$dateAndTime )

{

  http_response_code(400);
  $message = array('code'=>400,'status'=>0,'message'=>"Parameters missing");
  send_response($message);
  exit; 

}

$get_data=getDataFromTable('event','*',['eventID'=>$eventID],'');
if (!empty($_FILES['eventImage']['name'])) 
{

  if(!is_dir($folderName))
  {

    mkdir($folderName);

  }
           

  $uniquesavename1=uniqid();

  // $uniquesavename2=$folderName.$uniquesavename1.'.png';
  $uniquesavename=$folderName.$uniquesavename1.'.png';
  $file_tmp= $_FILES['eventImage']['tmp_name'];
      
  move_uploaded_file($file_tmp, $uniquesavename);

}

if (!empty($_FILES['hostImage']['name'])) 
{
  if(!is_dir($folderName1))
  {

    mkdir($folderName1);

  }
             

  $uniquesavename1=uniqid();

  // $uniquesavename2=$folderName.$uniquesavename1.'.png';
  $uniquesavename2=$folderName1.$uniquesavename1.'.png';
  $file_tmp= $_FILES['hostImage']['tmp_name'];
      
  move_uploaded_file($file_tmp, $uniquesavename2);
}


if(!empty($eventID))
{

  if (!empty($_FILES['eventImage']['name']))
  {
    unlink($get_data[0]['eventImage']);
    // $uniquesavename =$uniquesavename;
  }
  else {

    $uniquesavename=$get_data[0]['eventImage'];
  }

  if (!empty($_FILES['hostImage']['name']))
  {
    unlink($get_data[0]['hostImage']);
    // $uniquesavename2 =$uniquesavename2;
  }
  else {

    $uniquesavename2=$get_data[0]['hostImage'];
  }

  $update=updateDataTable('event',['eventID'=>$eventID],['eventName'=>$eventName,'categoryID'=>$categoryID,'eventDescription'=>$eventDescription,'date'=>$date, 'time'=>$time, 'dateAndTime'=>$dateAndTime, 'eventType'=>$eventType, 'latitude'=>$latitude, 'longitude'=>$longitude, 'location'=>$location, 'hostName'=>$hostName, 'hostImage'=>$uniquesavename2, 'forAdults'=>$forAdults,'eventCost'=>$eventCost, 'numberOfUsers'=>$numberOfUsers, 'eventImage'=>$uniquesavename, 'parkingCost'=>$parkingCost]);

  $updateEventTicket= updateDataTable('eventtickets',['eventID'=>$eventID, 'userID'=>$userID, 'categoryID'=>$categoryID],['ticketNo'=>$numberOfUsers,'updatedAt'=>$created]);

  if(!empty($djName))
  {

    $DjName= (explode(",",$djName));
    foreach ($DjName as $key =>$value) {

      if (!empty($_FILES['djImage']['name'])) 
      {

        if(!is_dir($folderName2))
        {

           mkdir($folderName2);

        }
           
        $uniquesavename1=uniqid();

        // $uniquesavename2=$folderName.$uniquesavename1.'.png';
        $uniquedjImage=$folderName2.$uniquesavename1.'.png';

        $file_tmp= $_FILES['djImage']['tmp_name'][$key];
            

        move_uploaded_file($file_tmp, $uniquedjImage);
        // print_r($uniquedjImage);
      }



      $checkDjNameExists=getDataFromTable('eventdj','*',['djName'=>$value],''); 
      if (empty($checkDjNameExists)) 
      {

        $insertDjName=insertDataTable('eventdj',['eventID'=>$eventID,'userID'=>$userID,'djName'=>$value,'djImage'=>$uniquedjImage, 'created'=>$created]);

      }
    }
  }

  if(!empty($artistName))
  {

    $ArtistName= (explode(",",$artistName));
    foreach ($ArtistName as $key =>$value) {


      if (!empty($_FILES['artistImage']['name'])) 
      {

        if(!is_dir($folderName3))

        {

          mkdir($folderName3);

        }
                   

        $uniquesavename1=uniqid();

        // $uniquesavename2=$folderName.$uniquesavename1.'.png';
        $uniqueArtistImage=$folderName3.$uniquesavename1.'.png';

        $file_tmp= $_FILES['artistImage']['tmp_name'][$key];
            

        move_uploaded_file($file_tmp, $uniqueArtistImage);
        // print_r($uniquedjImage);
          
      }

      $checkArtistNameExists=getDataFromTable('eventartist','*',['artistName'=>$value],'');
      if (empty($checkArtistNameExists)) {

        $insertArtistName=insertDataTable('eventartist',['eventID'=>$eventID,'userID'=>$userID,'artistName'=>$value, 'artistImage'=>$uniqueArtistImage,'created'=>$created]);

      }

    }

  }

  if ($update) {

    http_response_code(200);
    $message = array('code'=>200,'status'=>1,'message'=>"Event Updated Successfully");
    send_response($message);
    exit;

  }else{
    http_response_code(400);
    $message = array('code'=>400,'status'=>0,'message'=>"Something went wrong, please try again later.");
    send_response($message);
    exit;
  }

}else
{

  $checkEventNameExists=getDataFromTable('event','*',['eventName'=>$eventName,'eventID'=>$eventID],'');

  if (!empty($checkEventNameExists)) {
  $message = array('status'=>0,'message'=>"This event name is already exist.");
  send_response($message);
  exit;
  }

  $insert=insertDataTable('event',['userID'=>$userID,'eventName'=>$eventName,'categoryID'=>$categoryID,'eventDescription'=>$eventDescription,'date'=>$date,'time'=>$time, 'dateAndTime'=>$dateAndTime, 'eventType'=>$eventType,'latitude'=>$latitude,'longitude'=>$longitude,'location'=>$location, 'hostName'=>$hostName, 'hostImage'=>$uniquesavename2,'forAdults'=>$forAdults,'eventCost'=>$eventCost,'numberOfUsers'=>$numberOfUsers,'eventImage'=>$uniquesavename,'parkingCost'=>$parkingCost,'created'=>$created]);

  $addTickets=insertDataTable('eventtickets',['eventID'=>$insert, 'userID'=>$userID, 'categoryID'=>$categoryID, 'ticketNo'=>$numberOfUsers, 'ticketType'=>0,'personPerTicket'=>1,'ticketPrice'=>$eventCost,'ticketCatId'=>0,'description'=>$description,'created'=>$created,'disable'=>0]);

  $DjName= (explode(",",$djName));
  foreach ($DjName as $key =>$value) {

    if (!empty($_FILES['djImage']['name'])) 
    {
      if(!is_dir($folderName2))
      {

        mkdir($folderName2);

      }
           
      $uniquesavename1=uniqid();

      // $uniquesavename2=$folderName.$uniquesavename1.'.png';
      $uniquedjImage=$folderName2.$uniquesavename1.'.png';

      $file_tmp= $_FILES['djImage']['tmp_name'][$key];
          

      move_uploaded_file($file_tmp, $uniquedjImage);
      // print_r($uniquedjImage);

    }

    $insertDjName=insertDataTable('eventdj',['eventID'=>$insert,'userID'=>$userID,'djName'=>$value, 'djImage'=>$uniquedjImage,'created'=>$created]);
  }

  $ArtistName= (explode(",",$artistName));
  foreach ($ArtistName as $key =>$value) {


    if (!empty($_FILES['artistImage']['name'])) 
    {
      if(!is_dir($folderName3))
      {

        mkdir($folderName3);

      }
             
      $uniquesavename1=uniqid();

      // $uniquesavename2=$folderName.$uniquesavename1.'.png';
      $uniqueArtistImage=$folderName3.$uniquesavename1.'.png';

      $file_tmp= $_FILES['artistImage']['tmp_name'][$key];
          
      move_uploaded_file($file_tmp, $uniqueArtistImage);
      // print_r($uniquedjImage);

      
    }

    $insertArtistName=insertDataTable('eventartist',['eventID'=>$insert,'userID'=>$userID,'artistName'=>$value, 'artistImage'=>$uniqueArtistImage,'created'=>$created]);
  }

  if ($insert) {

    http_response_code(200);
    $message = array('code'=>200,'status'=>1,'message'=>"Event Created Successfully");
    send_response($message);
    exit;

  }else{

    http_response_code(400);
    $message = array('code'=>400,'status'=>0,'message'=>"Something went wrong, please try again later.");
    send_response($message);
    exit;

  } 

}


?>
