<?php
// ini_set('display_errors', '1');
// ini_set('display_startup_errors', '1');
// error_reporting(E_ALL);

include 'Functions.php';

header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');
$data=json_decode(file_get_contents("php://input"),true);
$header = apache_request_headers(); 

if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
  send_response($message);
  exit;  

}


$userID=$TokenExist[0]['userID'];
// print_r($userID);
$venueID=$_POST['venueID'];
$venueName = mysqli_real_escape_string($con,$_POST['venueName']);
$latitude=$_POST['latitude'];
$longitude=$_POST['longitude'];
$venueAddress = mysqli_real_escape_string($con,$_POST['venueAddress']);
$description = mysqli_real_escape_string($con,$_POST['description']);
$categoryID=$_POST['categoryID'];     //1=>Restaurant, 2=>Club, 3=>Bar, 4=>House Party
$NumberOfTickets=$_POST["NumberOfTickets"];
$ticketPrice = $_POST["ticketPrice"];
$barCodeImage=$_FILES['barCodeImage'];
$layoutImage=$_FILES['layoutImage'];
$barcodeDir='venue/barCodeImage/';
$layoutDir='venue/layoutImage/';
$created=time();

$get_data=getDataFromTable('event','*',['venueID'=>$venueID],'');
if (!empty($_FILES['barCodeImage']['name'])) 
{

  if(!is_dir($barcodeDir))
  {

    mkdir($barcodeDir);
  }
           
  $uniquesavename=time().'_'.uniqid().'.'.strtolower(pathinfo($_FILES['barCodeImage']['name'],PATHINFO_EXTENSION ));
  $targetFile = $barcodeDir . $uniquesavename;
  $file_tmp= $_FILES['barCodeImage']['tmp_name'];

  move_uploaded_file($file_tmp, $targetFile);

}

if (!empty($_FILES['layoutImage']['name'])) 
{

  if(!is_dir($layoutDir))
  {

    mkdir($layoutDir);
  }
           
  $uniquesavename1=time().'_'.uniqid().'.'.strtolower(pathinfo($_FILES['layoutImage']['name'],PATHINFO_EXTENSION ));
  $targetFile1 = $layoutDir . $uniquesavename1;
  $file_tmp1= $_FILES['layoutImage']['tmp_name'];

  move_uploaded_file($file_tmp1, $targetFile1);

}


if(!empty($venueID))
{

  if (!empty($_FILES['barCodeImage']['name']))
  {
    unlink($get_data[0]['barCodeImage']);
  }
  else {

    $uniquesavename=$get_data[0]['barCodeImage'];
  }


  if (!empty($_FILES['layoutImage']['name']))
  {
    unlink($get_data[0]['layoutImage']);
  }
  else {

    $uniquesavename1=$get_data[0]['layoutImage'];
  }

  $update= updateDataTable('venue',['venueID'=>$venueID],['venueName'=>$venueName, 'latitude'=>$latitude,'longitude'=>$longitude,'venueAddress'=>$venueAddress,'description'=>$description,'categoryID'=>$categoryID,'parkingImage'=>$uniquesavename,'layoutImage'=>$uniquesavename1,'updatedAt'=>$created]);

  
  
  if($categoryID==4)
  {
    $update= updateDataTable('venueticketsV2',['venueID'=>$venueID,'userID'=>$userID, 'categoryID'=>$categoryID,'ticketCatId'=>0,'isPurchased'=>0],['personPerTicket'=>1,'ticketPrice'=>$ticketPrice,'updatedAt'=>$created]);
  }

  http_response_code(200);
  $message =array('code'=>200,"status"=>1,"message"=>'Venue updated successfully.');
  send_response($message);
   

}else
{
  $addVenue=insertDataTable('venue',['userID'=>$userID,'venueName'=>$venueName, 'latitude'=>$latitude,'longitude'=>$longitude, 'venueAddress'=>$venueAddress,'description'=>$description,'categoryID'=>$categoryID,'parkingImage'=>$uniquesavename,'layoutImage'=>$uniquesavename1,'serviceCost'=>99,'created'=>$created]);

  if($addVenue)
  {
    $update= updateDataTable('venueimage',['userID'=>$userID,'venueID'=>0],['venueID'=>$addVenue,'updatedAt'=>$created]);

  if($categoryID!=4)
  {

    $update= updateDataTable('venueticketcategory',['userID'=>$userID,'venueID'=>0,'disable'=>0],['venueID'=>$addVenue,'updatedAt'=>$created]);
    $update= updateDataTable('venueticketsV2',['userID'=>$userID,'venueID'=>0,'disable'=>0],['venueID'=>$addVenue,'updatedAt'=>$created]);
  }


    http_response_code(200);
    $message =array('code'=>200,"status"=>1,"message"=>'Venue add successfully.');
    send_response($message);
    exit; 
  }else
  {
    http_response_code(400);
    $message = array('code'=>400,"status" => 0, "message" => "Somthing went wrong.". $con->error);
    send_response($message);
    exit; 

  }



}


if($categoryID==4)
{
 
  $getVenueTicket =getDataFromTable('venueticketsV2','section,ticketID',['venueID'=>$venueID, 'userID'=>$userID, 'categoryID'=>$categoryID],' ORDER BY ticketID DESC')[0];
  if (!empty($getVenueTicket)) {

    $xArray = explode("Section_", $getVenueTicket['section']);
    $x = 1+$xArray[1];

  }
  else{
    $x = 1;
  }


  $totalTicket =getDataFromTable('venueticketsV2','count(*) as totalCount',['venueID'=>$venueID, 'userID'=>$userID, 'categoryID'=>$categoryID],'')[0];

  
  if ($totalTicket['totalCount'] > $NumberOfTickets) {
    http_response_code(400);
    $message = array('code'=>400,"status" => 0, "message" => "Please enter ticket more than added tickets". $con->error);
    send_response($message);
    exit; 
  }

  if (!empty($totalTicket) && $NumberOfTickets > $totalTicket['totalCount'] ) {
    while($x <= $NumberOfTickets) {
      
      $section = 'Section_'.$x;
      $ticketNo = 'Ticket_No_'.uniqid();

      if(!empty($venueID))
      {
        
        $addTickets=insertDataTable('venueticketsV2',['venueID'=>$venueID, 'userID'=>$userID, 'categoryID'=>$categoryID, 'ticketNo'=>$ticketNo,'personPerTicket'=>1, 'section'=>$section,'ticketPrice'=>$ticketPrice,'created'=>$created,'disable'=>0]);
      }else
      {

        $addTickets=insertDataTable('venueticketsV2',['venueID'=>$addVenue, 'userID'=>$userID, 'categoryID'=>$categoryID, 'ticketNo'=>$ticketNo,'personPerTicket'=>1, 'section'=>$section,'ticketPrice'=>$ticketPrice,'created'=>$created,'disable'=>0]);
      }

      $x++;
    }
  }
}


?>