<?php
include 'Functions.php';

header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');

$data=json_decode(file_get_contents("php://input"),true);
$header = apache_request_headers(); 

if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
  send_response($message);
  exit;  

}

$userID=$TokenExist[0]['userID'];
$otherUserID=$data['otherUserID'];
$created=time();

$addFriendExist=getDataFromTable('favusers','*',['userID'=>$userID, 'otherUserID'=>$otherUserID],'')[0];

if(empty($addFriendExist))
{

  $insert=insertDataTable('favusers',['userID'=>$userID,'otherUserID'=>$otherUserID, 'status'=>1,'created'=>$created]);
  if($insert)
  {

    $userDetails=getDataFromTable('users','*',['userID'=>$userID],'')[0];
    $name=$userDetails['userName'];

    $insertNotification=insertDataTable('notification',['userID'=>$otherUserID,'otherUserID'=>$userID,'notificationType'=>1,'status'=>1,'detailsID'=>$insert,'description'=>'send you a request','title'=>$name,'created'=>$created]);
    $getNotification=getDataFromTable('notification','*',['notificationID'=>$insertNotification],'')[0];

    // $userDetails=getDataFromTable('users','*',['userID'=>$getNotification['userID']],'')[0];

    $notificationMessage = $userDetails['userName'];
    $message= "Sent friend request to you.";

    $notificationUser = getDataFromTable('usertoken','*',['userID'=>$getNotification['userID']],'');

    foreach ($notificationUser as $key1 => $valueUser) {
      if($valueUser['deviceType'] == 1) {
        $push_notification = sendpush_android($notificationMessage,$message, $valueUser['deviceToken'], $getNotification);
      }
      if($valueUser['deviceType'] == 2) {
        $push_notification = send_push_IOS_By_p8($notificationMessage,$message,$valueUser['deviceToken'],$getNotification,0);
      }
    }

    http_response_code(200);
    $message =array('code'=>200,"status"=>1,'isFriend'=>1,"message"=>"Sent request Successfully");
    send_response($message);
    exit; 
  }

  else
  {

    http_response_code(400);
    $message = array('code'=>400, "status" => 0, "message" => "Something went wrong");
    send_response($message);
    exit;

  }

}else

{
  // ['userID'=>$userID, 'otherUserID'=>$otherUserID]
  $delete = deleteDataTable('favusers',['userID'=>$userID, 'otherUserID'=>$otherUserID]);
  $delete = deleteDataTable('favusers',['otherUserID'=>$userID, 'otherUserID'=>$userID]);
  // $delete = deleteDataTable('favusers',['favID'=>$addFriendExist[0]['favID']]);
  if($delete)
  {
    $deleteNotification = deleteDataTable('notification',['userID'=>$otherUserID,'otherUserID'=>$userID,'notificationType'=>1,'detailsID'=>$addFriendExist['favID']]);

    http_response_code(200);
    $message =array('code'=>200,"status"=>1,'isFriend'=>0,"message"=>"Unfriend Successfully");
    send_response($message);
    exit; 

  }

  else
  {
    http_response_code(400);
    $message = array('code'=>400, "status" => 0, "message" => "Something went wrong");
    send_response($message);
    exit;
  }
}
?> 