<?php
include 'Functions.php';
header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');
$header = apache_request_headers(); 

$data=json_decode(file_get_contents("php://input"),true);

if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
  send_response($message);
  exit;  

}

$userID=$TokenExist[0]['userID'];
$id=$data["id"];
$type = $data['type'];
$replyID=$data["replyID"];
$replyTo=$data["replyTo"];
$comments = mysqli_real_escape_string($con,$data["comments"]);
$created=time();
// $perpage=$data['perpage'];
// $pagenumber=$data['pagenumber'];
// $offset=($pagenumber-1)*$perpage;

if(!$id)
{
  http_response_code(400);
  $message = array('code'=>400,'status'=>0,'message'=>"Parameters missing");
  send_response($message);
  exit; 
}

if ($type ==1) {

  $addComments=insertDataTable('usercomments',['otherUserID'=>$id, 'userID'=>$userID, 'comments'=>$comments, 'replyID'=>$replyID,'replyTo'=>$replyTo,'disable'=>0,'created'=>$created]);

  // $commentsListing=getUserCommentsListing($id,$perpage,$offset);
  // $commentsListing=getUserCommentsListingV2($id);
  $commentsListing=getUserCommentsListingV3($id,$replyID,$replyTo,$userID)[0];
}elseif ($type==2) {

  $addComments=insertDataTable('eventcomments',['eventID'=>$id, 'userID'=>$userID, 'comments'=>$comments, 'replyID'=>$replyID,'replyTo'=>$replyTo,'disable'=>0,'created'=>$created]);
  if (!empty($replyTo) and $replyTo!=$userID) {
    $userDetails=getDataFromTable('users','*',['userID'=>$userID],'')[0];

      $notificationMessage = $userDetails['userName'];
      $message = "reply to your comment.";
    
      $notificationData = insertDataTable('notification',['title'=>$notificationMessage,'description'=>$message,'notificationType'=>10,'userID'=>$replyTo,'otherUserID'=>$userID,'detailsID'=>$id,'created'=>$created]);

      $where=['notificationID'=>$notificationData];
      $notificationDetails =getDataFromTable('notification','*',$where,'')[0];
      
      $notificationUser=getDataFromTable('usertoken','*',['userID'=>$notificationDetails['userID']],'');
      foreach ($notificationUser as $key1 => $valueUser) {
        if($valueUser['deviceType'] == 1) {
          $push_notification = sendpush_android($notificationMessage,$message, $valueUser['deviceToken'], $notificationDetails);
        }
        if($valueUser['deviceType'] == 2) {
          $push_notification = send_push_IOS_By_p8($notificationMessage,$message,$valueUser['deviceToken'],$notificationDetails,0);
        }
      }

  }

  // $commentsListing=getEventCommentsListing($id,$perpage,$offset);
  // $commentsListing=getEventCommentsListingV2($id)[0];
  $commentsListing=getEventCommentsListingV3($id,$replyID,$replyTo,$userID)[0];
}else{
  
  http_response_code(400);
  $message =array('code'=>400,'status'=>0,'message'=>'Enter valid type');
  send_response($message);
  exit; 

}

if($addComments)
{


  http_response_code(200);
  $message =array('code'=>200,"status"=>1,"message"=>"Add comment successfully.", "data"=>$commentsListing);
  send_response($message);
  exit; 

}
else
{

  http_response_code(400);
  $message = array('code'=>400,"status" => 0, "message" => "Something went wrong");
  send_response($message);

}

?>