<?php
// ini_set('display_errors', '1');
// ini_set('display_startup_errors', '1');
// error_reporting(E_ALL);

include 'Functions.php';
require_once('vendorStripe/autoload.php');

header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');
$data=json_decode(file_get_contents("php://input"),true);
$header = apache_request_headers(); 

if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
  send_response($message);
  exit;  

}



$type=$_POST['type'];  //1=> reserve tickets for reserve, 2=> booking tickets for venue and event
$eventCost=$_POST['eventCost']; 
$bookinguserID=$TokenExist[0]['userID'];
$hostuserID=$_POST['hostuserID'];
$venueID=$_POST['venueID'];
$eventID=$_POST['eventID'];
$ticketID=$_POST['ticketID'];
$isParking=$_POST['isParking'];
$startDate=$_POST['startDate'];
$startTime=$_POST['startTime'];
$endDate=$_POST['endDate'];
$endTime=$_POST['endTime'];
$startDateAndTime=$_POST['startDateAndTime'];
$endDateAndTime=$_POST['endDateAndTime'];
$cardID = $_POST['cardID'];
$paymentStatus=$_POST['paymentStatus'];
$payAsSplit=$_POST['payAsSplit'];
$pendingAmount=$_POST['pendingAmount'];
$totalAmount=$_POST['totalAmount'];
$paidAmount=$_POST['paidAmount'];
$refundAmount=$_POST['refundAmount'];
$handlingFee=$_POST['handlingFee'];
$ticketCount=$_POST['ticketCount'];
$note='payment';
$created=time();


if($type==1)
{
  $ticketID= (explode(",",$ticketID));
  foreach ($ticketID as $key =>$value) 
  { 
    $insert=insertDataTable('eventvenuebooking',['venueID'=>$venueID,'eventID'=>$eventID,'hostuserID'=>$hostuserID,'bookinguserID'=>$bookinguserID,'ticketID'=>$value,'startDate'=>$startDate,'startTime'=>$startTime,'endDate'=>$endDate,'endTime'=>$endTime,'startDateAndTime'=>$startDateAndTime,'endDateAndTime'=>$endDateAndTime,'isReserve'=>1,'isParking'=>$isParking,'ticketCount'=>$ticketCount,'created'=>$created]); 
  }  

  if($insert) 
  {
    $updateEventTicket= updateDataTable('event',['eventID'=>$eventID, 'venueID'=>$venueID],['eventCost'=>$eventCost,'updatedAt'=>$created]);

    http_response_code(200);
    $message = array('code'=>200,'status'=>1,'message'=>"Event tickets are reserved successfully");
    send_response($message);
    // exit;
  }else{

    http_response_code(400);
    $message = array('code'=>400,'status'=>0,'message'=>"Something went wrong, please try again later.");
    send_response($message);
    exit;

  } 
}

if($type==2)
{

  if(!empty($bookinguserID))
  {
    $accountDetails = getDataFromTable('users','*',['userID'=>$bookinguserID],'')[0];
    if(empty($accountDetails)) {
      http_response_code(400);
      $message = array('code'=>400,'status'=>0,'message'=>"This user not found.");
      send_response($message);
      exit; 

    }
  }

  elseif(!empty($hostuserID))
  {
    $accountDetails = getDataFromTable('users','*',['userID'=>$hostuserID],'')[0];
    if (empty($accountDetails)) {
      http_response_code(400);
      $message = array('code'=>400,'status'=>0,'message'=>"This host not found.");
      send_response($message);
      exit; 

    }
    if (empty($accountDetails['stripeAccountId'])) {
      http_response_code(400);
      $message = array('code'=>400,'status'=>0,'message'=>"Reciever account not available.");
      send_response($message);
      exit; 
    }
  }

  elseif (!empty($venueID)){
    $getVenueDetails=getDataFromTable('venue','*',['venueID'=>$venueID],'')[0];
    if (empty($getVenueDetails)) {
      http_response_code(400);
      $message = array('code'=>400,'status'=>0,'message'=>"This event not found.");
      send_response($message);
      exit; 

    }
    $accountDetails = getDataFromTable('users','*',['userID'=>$getVenueDetails['userID']],'')[0];
    if (empty($accountDetails)) {
      http_response_code(400);
      $message = array('code'=>400,'status'=>0,'message'=>"Venue user not found.");
      send_response($message);
      exit; 

    }
    // print_r($accountDetails);
    if (empty($accountDetails['stripeAccountId'])) {
      http_response_code(400);
      $message = array('code'=>400,'status'=>0,'message'=>"Reciever account not available.");
      send_response($message);
      exit; 
    }
  }

  elseif (!empty($eventID)){
    $getEventDetails=getDataFromTable('event','*',['eventID'=>$eventID],'')[0];
    if (empty($getEventDetails)) {
      http_response_code(400);
      $message = array('code'=>400,'status'=>0,'message'=>"This event not found.");
      send_response($message);
      exit; 

    }
    $accountDetails = getDataFromTable('users','*',['userID'=>$getEventDetails['userID']],'')[0];
    if (empty($accountDetails)) {
      http_response_code(400);
      $message = array('code'=>400,'status'=>0,'message'=>"Event user not found.");
      send_response($message);
      exit; 

    }
    // print_r($accountDetails);
    if (empty($accountDetails['stripeAccountId'])) {
      http_response_code(400);
      $message = array('code'=>400,'status'=>0,'message'=>"Reciever account not available.");
      send_response($message);
      exit; 
    }
  }else {
    http_response_code(200);
    $message = array('code'=>200,'status'=>0,'message'=>"Parameter missing.");
    send_response($message);
    exit; 
  }

  $where = ['userID'=>$bookinguserID];
  $existDetails = getDataFromTable('users','*',$where,'')[0];
  if(empty($existDetails)){

    http_response_code(400);
    $message = array('code'=>400,'status'=>0,'message'=>"This user does not exist.");
    send_response($message);
    exit; 

  }

  $customerId = $existDetails['customerId'];

  if(empty($customerId)){

    http_response_code(400);
    $message = array('code'=>400,'status'=>0,'message'=>"No card added.");
    send_response($message);
    exit; 
  }

  // Stripe Authentication 
  $stripe = new \Stripe\StripeClient($stripe['secret_key']);

  // Charge from card

  try
  {

    $cardCharges = $stripe->charges->create([
      'amount' => $totalAmount*100,
      'currency' => 'USD',
      'source' => $cardID,
      'customer'=> $customerId,
      'description' => $note,
    ]);

    // echo json_encode($cardCharges['id']);
    // exit();
  }catch (\Stripe\Error\Base $e) {
    http_response_code(400);
      // Code to do something with the $e exception object when an error occurs
      $json = array('code'=>400,
        'status'=>205,
        'success' => 'error',
        'paymentStatus'=>2,
        'message'=>$e->getMessage()
      );
      echo json_encode($json);exit();
  } catch (Exception $e) {
    http_response_code(400);
      // Catch any other non-Stripe exceptions
      $json = array('code'=>400,
        'status'=>206,
        'success' => 'error',
        'paymentStatus'=>2,
        'message'=>$e->getMessage()
      );
      echo json_encode($json);exit();
  }

  
  
  if(!empty($eventID))
  {
    $ticketNo = generateSalt(6);
    $tickets= (explode(",",$ticketID));
    $ticketsDetail=[];
    foreach ($tickets as $key => $value) {
      $value;
  
      $ticketsData = getTicketsDataWithInnerJoin($value)[0];
      $ticketsDetail = $ticketsData['categoryName'].'_'.$ticketsData['section'];
    
    // $ticketsList = implode(', ', $ticketsDetail);

    $insert=insertDataTable('eventvenuebooking',['venueID'=>$venueID,'eventID'=>$eventID,'hostuserID'=>$hostuserID,'bookinguserID'=>$bookinguserID,'cardPaidFrom'=>$cardID,'ticketCount'=>$ticketCount,'ticketID'=>$value,'ticketDetail'=>$ticketsDetail,'startDate'=>$startDate,'startTime'=>$startTime,'endDate'=>$endDate,'endTime'=>$endTime,'startDateAndTime'=>$startDateAndTime,'endDateAndTime'=>$endDateAndTime,'ticketNo'=>$ticketNo,'totalAmount'=>$totalAmount,'paidAmount'=>$paidAmount,'handlingFee'=>$handlingFee,'refundAmount'=>$refundAmount,'transactionID'=>$cardCharges['id'],'isReserve'=>1,'paymentStatus'=>$paymentStatus,'payAsSplit'=>$payAsSplit,'pendingAmount'=>$pendingAmount,'isParking'=>$isParking,'isPurchased'=>1,'created'=>$created]);
    }


    if($insert)
    {
      http_response_code(200);
      $message = array('code'=>200,'status'=>1,'venueID'=>$venueID,'eventID'=>$eventID,'message'=>'Ticket purchased successfully.','transactionId'=>$cardCharges['id']);
      send_response($message);
      exit;
    }else{
      http_response_code(400);
      $message = array('code'=>400,"status" => 0, "message" => "Something went wrong, failed to purchase ticket.");
      send_response($message);
      exit;
    }  
  
  }else
  {
    $ticketNo = generateSalt(6);
    $tickets= (explode(",",$ticketID));
    $ticketsDetail=[];
    foreach ($tickets as $key => $value) {
      $value;
      $ticketsData = getTicketsDataWithInnerJoin($value)[0];
      $ticketsDetail = $ticketsData['categoryName'].'_'.$ticketsData['section'];
    
    // $ticketsList = implode(', ', $ticketsDetail);

    $insert=insertDataTable('eventvenuebooking',['venueID'=>$venueID,'eventID'=>$eventID,'hostuserID'=>$hostuserID,'bookinguserID'=>$bookinguserID,'cardPaidFrom'=>$cardID,'ticketCount'=>$ticketCount,'ticketID'=>$value,'ticketDetail'=>$ticketsDetail,'startDate'=>$startDate,'startTime'=>$startTime,'endDate'=>$endDate,'endTime'=>$endTime,'startDateAndTime'=>$startDateAndTime,'endDateAndTime'=>$endDateAndTime,'ticketNo'=>$ticketNo,'totalAmount'=>$totalAmount,'paidAmount'=>$paidAmount,'handlingFee'=>$handlingFee,'refundAmount'=>$refundAmount,'transactionID'=>$cardCharges['id'],'paymentStatus'=>$paymentStatus,'payAsSplit'=>$payAsSplit,'pendingAmount'=>$pendingAmount,'isParking'=>$isParking,'isPurchased'=>1,'created'=>$created]); 
    }

    if($insert)
    {
      http_response_code(200);
      $message = array('code'=>200,'status'=>1,'venueID'=>$venueID,'message'=>'Ticket purchased successfully.','transactionId'=>$cardCharges['id']);
      send_response($message);
      exit;
    }else{
      http_response_code(400);
      $message = array('code'=>400,"status" => 0, "message" => "Something went wrong, failed to purchase ticket.");
      send_response($message);
      exit;
    }  
  }
  
}


function getTicketsDataWithInnerJoin($ticketID)
{
  global $con;
  global $config;
  $array=array();

  $query="SELECT venuetickets.*,venueticketcategory.*
  FROM venuetickets
  INNER JOIN venueticketcategory ON venuetickets.ticketCatId = venueticketcategory.venueTicketCatId WHERE venuetickets.ticketID=$ticketID";
  // print_r($query);
  $run = $con->query($query);
  while($result = $run->fetch_assoc())
  {

    array_push($array, $result);
  }
  return $array;
}


// function checkBookingAlready($hostuserID,$bookinguserID,$venueID,$ticketID,$startDate,$startTime,$endDate,$endTime,$startDateAndTime,$endDateAndTime)
// {
// 	global $con;
//   global $config;
//   $array=array();
   

//     $query="SELECT * FROM eventvenuebooking WHERE venueID=$venueID AND bookingUserID!=$bookinguserID AND hostuserID=$hostuserID AND isPurchased=1 AND ticketID IN($ticketID) AND startDateAndTime BETWEEN('$startDateAndTime' AND '$endDateAndTime') AND endDateAndTime BETWEEN('$startDateAndTime' AND '$endDateAndTime') AND disable=0 "; 
//     // print_r($query);die();
//   $run = $con->query($query);
//   while($result = $run->fetch_assoc())
//   {

//     array_push($array, $result);
//   }

//   return $array;
// }

?>