<?php
header('Content-Type: application/json');
header('Access-Control-Allow-Origin:*'); 
header('Access-Control-Allow-Methods: POST');

include_once('Functions.php'); // function file
$header = apache_request_headers(); 

if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
  send_response($message);
  exit;  

}
require_once('vendorStripe/autoload.php');

$userID = $TokenExist[0]['userID'];
$cardID = $_POST['cardID'];
$created = time();

$where = ['userID'=>$userID];
$existDetails = getDataFromTable('users','*',$where,'')[0];
if(empty($existDetails)){

	http_response_code(400);
	$message = array('code'=>400,'status'=>0,'message'=>"This user does not exist.");
	send_response($message);
	exit; 

}

$customerId = $existDetails['customerId'];

// Stripe Authentication 
$stripe = new \Stripe\StripeClient($stripe['secret_key']);

if(empty($customerId)){

	http_response_code(400);
	$message = array('code'=>400,'status'=>0,'message'=>"No card added.");
	send_response($message);
	exit; 
}

// Delete a card
try
{

	$deleteCard = $stripe->customers->deleteSource(
	  $customerId,
	  $cardID,
	  []
	);

	// echo json_encode($deleteCard);
	// exit();
}catch (\Stripe\Error\Base $e) {
  	// Code to do something with the $e exception object when an error occurs
  	$json = array('status'=>205,
   		'success' => 'error',
   		'message'=>$e->getMessage()
   	);
   	echo json_encode($json);exit();
} catch (Exception $e) {
  	// Catch any other non-Stripe exceptions
  	$json = array('status'=>206,
   		'success' => 'error',
   		'message'=>$e->getMessage()
   	);
  	echo json_encode($json);exit();
}

deleteDataTable('cards',['cardID'=>$cardID]);
http_response_code(200);
$message = array('code'=>200,'status'=>1,'message'=>"Your card deleted successfully");
send_response($message);
exit; 
