<?php
header('Content-Type: application/json');
header('Access-Control-Allow-Origin:*'); 
header('Access-Control-Allow-Methods: POST');

include_once('Functions.php'); // function file

$header = apache_request_headers(); 

if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
	http_response_code(401);
	$message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
	send_response($message);
	exit;  

}
require_once('vendorStripe/autoload.php');

$userID = $TokenExist[0]['userID'];
// $created = time();

$where = ['userID'=>$userID];
$existDetails = getDataFromTable('users','*',$where,'')[0];
// $existDetails = getDataFromTable($table_name,$get,$where,$orderBy);
if(empty($existDetails)){

	http_response_code(400);
	$message = array('code'=>400,'status'=>0,'message'=>"This user does not exist.");
	send_response($message);
	exit; 

}

// $paypalId = $existDetails['paypalId'];
// if(!empty($paypalId)){
// 	$where = ['userID'=>$userID];
// 	$paypalDetails = getDataFromTable('users','paypalId,paypalEmail',$where,'ORDER BY created DESC');
// }else{
// 	$paypalDetails =[];
// }

$customerId = $existDetails['customerId'];
if(!empty($customerId)){
	
	// Stripe Authentication 
	$stripe = new \Stripe\StripeClient($stripe['secret_key']);

	// if(empty($customerId)){

	// 	http_response_code(400);
	// 	$message = array('code'=>400,'status'=>0,'message'=>"No card added.");
	// 	send_response($message);
	// 	exit; 
	// }

	// List all cards
	try
	{
		$getCardDetails = $stripe->customers->allSources(
		  $customerId,
		  ['object' => 'card', 'limit' => 20]
		);
		// echo json_encode($getCardDetails['data']);
		// exit();
	}catch (\Stripe\Error\Base $e) {
	  	// Code to do something with the $e exception object when an error occurs
	 /* 	$json = array('status'=>205,
	   		'success' => 'error',
	   		'message'=>$e->getMessage()
	   	);
	   	echo json_encode($json);exit();*/

	  	$getCardDetails = [];
	} catch (Exception $e) {
	  	// Catch any other non-Stripe exceptions
	  	/*$json = array('status'=>206,
	   		'success' => 'error',
	   		'message'=>$e->getMessage()
	   	);
	  	echo json_encode($json);exit();*/

	  	$getCardDetails = [];
	}

	// Retrieve a customer
	$getDefaultSource  = $stripe->customers->retrieve(
	  $customerId,
	  []
	);
	// echo json_encode($getDefaultSource);
	// exit();

	$data = array();
	foreach ($getCardDetails as $key) {
		// echo json_encode($key);
		// exit();
		$card_id = $key->id;
		// print_r($card_id);
		$brand = $key->brand;
		$country = $key->country;
		$exp_month = $key->exp_month;
		$exp_year = $key->exp_year;
		$last4 = $key->last4;
		$card_holder_name = $key->name;
		if($card_holder_name==null)
		{
			$card_holder_name='';
		}
		$card_detail['card_id'] = $card_id;
		$card_detail['brand'] = $brand;
		$card_detail['country'] = $country;
		$card_detail['exp_month'] = (string)$exp_month;
		$card_detail['exp_year'] = (string)$exp_year;
		$card_detail['last4'] = $last4;
		$card_detail['card_holder_name'] = $card_holder_name;
		$card_detail['fingerprint'] = $key->fingerprint;
		if ($existDetails['defaultPaymentMethod']==0) {
			$card_detail['isDefault']='0';
		}
		elseif ($existDetails['defaultPaymentMethod']==2) {
			$card_detail['isDefault']='0';
		}
		else
		{
			if ($getDefaultSource->default_source==$card_id) {
		
		  		$card_detail['isDefault']='1';
		  	}
		  	else
		  	{
		  		$card_detail['isDefault']='0';
		  	}
		} 
		array_push($data, $card_detail);
	}
	// echo json_encode($data);
	// exit();
	$finalData = array();

	foreach ($data as $value) {
		if (!isset($finalData[$value['fingerprint']])){
			$finalData[$value['fingerprint']] =$value;
		}
	}
	$finalData = array_values($finalData);

}else{
	$finalData =[];
}
if($getCardDetails || $paypalDetails)
{
	$message = array('code'=>200,'status'=>1,'message'=>'List of Cards','data'=>$finalData);
	send_response($message);
	exit;
}
else
{
	$message = array('code'=>400,'status'=>0,'message'=>'No Data Found.','data'=>$finalData);
	send_response($message);
	exit;
}
?>