<?php
header('Content-Type: application/json');
header('Access-Control-Allow-Origin:*'); 
header('Access-Control-Allow-Methods: POST');

include 'Functions.php';
include_once('validateToken.php'); // if(empty($TokenExist)) Token is invalid
require_once('vendorStripe/autoload.php');

$userID = $TokenExist[0]['userID'];
$otherUserId = $_POST['otherUserId'];
$amount = $_POST['amount'];
$note = $_POST['note'];
$type = $_POST['type']; 
$cardId = $_POST['cardId'];
$splitID = $_POST['splitID'];

$eventID = $_POST['eventID'];
$ticketCount = $_POST['ticketCount'];
$created = time();


if (!empty($splitID)) {
	// 0->success,1->pending,2->failed,3->request,4->reject request
	$getDetails = getDataFromTable('splitpayment','*',['splitID'=>$splitID],'')[0];
	if (empty($getDetails)){
		http_response_code(400);
		$message = array('code'=>400,'status'=>0,'message'=>"Payment request not found.");
		send_response($message);
		exit; 
	}
	if (!empty($getDetails)) {
		$accountDetails = getDataFromTable('users','*',['userID'=>$getDetails['sendBy']],'')[0];
		if (empty($accountDetails)) {
			http_response_code(400);
			$message = array('code'=>400,'status'=>0,'message'=>"This user not found.");
			send_response($message);
			exit; 

		}
		if (empty($accountDetails['stripeAccountId'])) {
			http_response_code(400);
			$message = array('code'=>400,'status'=>0,'message'=>"Reciever account not available.");
			send_response($message);
			exit; 
		}

		if ($getDetails['status']=='1'){
			http_response_code(400);
			$message = array('code'=>400,'status'=>0,'message'=>"Payment already paid successfully.");
			send_response($message);
			exit; 
		}
		// if ($getDetails['status']=='1') {
		// 	http_response_code(200);
		// 	$message = array('code'=>200,'status'=>0,'message'=>"Payment paid by you, pending to update in receiver account.");
		// 	send_response($message);
		// 	exit; 
		// }
		
		if ($getDetails['status']=='4') {
			http_response_code(400);
			$message = array('code'=>400,'status'=>0,'message'=>"Payment rejected by you.");
			send_response($message);
			exit; 
		}	
	}

}
elseif (!empty($otherUserId)) {


	$accountDetails = getDataFromTable('users','*',['userID'=>$otherUserId],'')[0];
	if (empty($accountDetails)) {
		http_response_code(400);
		$message = array('code'=>400,'status'=>0,'message'=>"This user not found.");
		send_response($message);
		exit; 

	}
	if (empty($accountDetails['stripeAccountId'])) {
		http_response_code(400);
		$message = array('code'=>400,'status'=>0,'message'=>"Reciever account not available.");
		send_response($message);
		exit; 
	}
	
	// $getDetails = getDataFromTable('userpaid','*',['paidByUser'=>$userID,'otherUserID'=>$otherUserId],'')[0];
	// if (!empty($getDetails)) {
	// 	if ($getDetails['paymentStatus']=='1') {
	// 		http_response_code(400);
	// 		$message = array('code'=>400,'status'=>0,'message'=>"Payment already paid successfully.");
	// 		send_response($message);
	// 		exit; 
	// 	}
	// 	// if ($getDetails['paymentStatus']=='1') {
	// 	// 	http_response_code(200);
	// 	// 	$message = array('code'=>200,'status'=>0,'message'=>"Payment paid by you, pending to update in receiver account.");
	// 	// 	send_response($message);
	// 	// 	exit; 
	// 	// }
			
	// }

}

elseif (!empty($eventID)){
	$getEventDetails=getDataFromTable('event','*',['eventID'=>$eventID],'')[0];
	if (empty($getEventDetails)) {
		http_response_code(400);
		$message = array('code'=>400,'status'=>0,'message'=>"This event not found.");
		send_response($message);
		exit; 

	}

	$accountDetails = getDataFromTable('users','*',['userID'=>$getEventDetails['userID']],'')[0];
	if (empty($accountDetails)) {
		http_response_code(400);
		$message = array('code'=>400,'status'=>0,'message'=>"Event user not found.");
		send_response($message);
		exit; 

	}
	if (empty($accountDetails['stripeAccountId'])) {
		http_response_code(400);
		$message = array('code'=>400,'status'=>0,'message'=>"Reciever account not available.");
		send_response($message);
		exit; 
	}

	$getDetails = getDataFromTable('purchaseeventticket','*',['paidByUser'=>$userID,'eventID'=>$eventID],'')[0];
	if (!empty($getDetails)) {
		if ($getDetails['paymentStatus']=='1') {
			http_response_code(400);
			$message = array('code'=>400,'status'=>0,'message'=>"Ticket already buy.");
			send_response($message);
			exit; 
		}
		// if ($getDetails['paymentStatus']=='1') {
		// 	http_response_code(200);
		// 	$message = array('code'=>200,'status'=>0,'message'=>"Payment paid by you, pending to update in receiver account.");
		// 	send_response($message);
		// 	exit; 
		// }
			
	}
}
else {
	http_response_code(200);
	$message = array('code'=>200,'status'=>0,'message'=>"Parameter missing.");
	send_response($message);
	exit; 
}

$where = ['userID'=>$userID];
$existDetails = getDataFromTable('users','*',$where,'')[0];
if(empty($existDetails)){

	http_response_code(400);
	$message = array('code'=>400,'status'=>0,'message'=>"This user does not exist.");
	send_response($message);
	exit; 

}

$customerId = $existDetails['customerId'];

if(empty($customerId)){

	http_response_code(400);
	$message = array('code'=>400,'status'=>0,'message'=>"No card added.");
	send_response($message);
	exit; 
}

// Stripe Authentication 
$stripe = new \Stripe\StripeClient($stripe['secret_key']);

// Charge from card
try
{

	$cardCharges = $stripe->charges->create([
	  'amount' => $amount*100,
	  'currency' => 'USD',
	  'source' => $cardId,
	  'customer'=> $customerId,
	  'description' => $note,
	]);

	// echo json_encode($cardCharges['id']);
	// exit();
}catch (\Stripe\Error\Base $e) {
	http_response_code(400);
  	// Code to do something with the $e exception object when an error occurs
  	$json = array('code'=>400,
  		'status'=>205,
   		'success' => 'error',
   		'paymentStatus'=>2,
   		'message'=>$e->getMessage()
   	);
   	echo json_encode($json);exit();
} catch (Exception $e) {
	http_response_code(400);
  	// Catch any other non-Stripe exceptions
  	$json = array('code'=>400,
  		'status'=>206,
   		'success' => 'error',
   		'paymentStatus'=>2,
   		'message'=>$e->getMessage()
   	);
  	echo json_encode($json);exit();
}

if(!empty($cardCharges['id'])){

	
	if (!empty($splitID)) {

  		$updated=updateDataTable('splitpayment',['splitID'=>$splitID],['cardPaidFrom'=>$cardId,'type'=>$type,'transactionID'=>$cardCharges['id'],'note'=>$note,'status'=>1,'updatedAt'=>time()]);
  		if ($updated) {
  			deleteDataTable('notification',['splitID'=>$splitID]);
   			$message="Payment charge from card successfully";
  		}else{
  			http_response_code(400);
			$message = array('code'=>400,"status" => 0, "message" => "Something went wrong, failed to send split payment.");
			send_response($message);
			exit; 
  		}
	}
	elseif (!empty($otherUserId)){

	  	$inserted =insertDataTable('userpaid',['paidByUser'=>$userID,'cardPaidFrom'=>$cardId,'otherUserID'=>$otherUserId,'amount'=>$amount,'type'=>$type,'transactionID'=>$cardCharges['id'],'note'=>$note,'paymentStatus'=>1,'created'=>$created]);
	  	if ($inserted) {
	  		$message="Payment charge from card successfully";
	  	}else{
  			http_response_code(400);
			$message = array('code'=>400,"status" => 0, "message" => "Something went wrong, failed to sent payment.");
			send_response($message);
			exit; 
  		}
	}

	elseif (!empty($eventID)){
		$ticketNo = generateSalt(6);
		$inserted =insertDataTable('purchaseeventticket',['paidByUser'=>$userID,'cardPaidFrom'=>$cardId,'eventID'=>$eventID,'ticketCount'=>$ticketCount,'ticketNo'=>$ticketNo,'amount'=>$amount,'type'=>$type,'transactionID'=>$cardCharges['id'],'note'=>$note,'paymentStatus'=>1,'created'=>$created]);
		if ($inserted) {
			// print_r($inserted);

			$getEventDetails=getDataFromTable('event','*',['eventID'=>$eventID],'')[0];
			$categoryID=$getEventDetails['categoryID'];
			$no = $getEventDetails['numberOfUsers'];
			$numberOfUsers=$no - $ticketCount;
			// print_r($numberOfUsers);

			$update=updateDataTable('event',['eventID'=>$eventID],['numberOfUsers'=>$numberOfUsers,'updatedAt'=>$created]);

  			// $updateEventTicket= updateDataTable('eventtickets',['eventID'=>$eventID, 'categoryID'=>$categoryID],['ticketNo'=>$numberOfUsers,'updatedAt'=>$created]);

			$message="Ticket purchased successfully.";
		}else{
  			http_response_code(400);
			$message = array('code'=>400,"status" => 0, "message" => "Something went wrong, failed to purchase ticket.");
			send_response($message);
			exit; 
  		}
	}


	http_response_code(200);
	$message = array('code'=>200,'status'=>1,'note'=>$note,'paymentStatus'=>1,'splitID'=>$splitID,'eventID'=>$eventID,'message'=>$message,'transactionId'=>$cardCharges['id']);
	send_response($message);
	exit; 
}
