<?php
header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');
include 'Functions.php';

$header = apache_request_headers(); 
if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
  send_response($message);
  exit;  

}

$userID=$TokenExist[0]['userID'];
$lobbyID=$_POST['lobbyID'];
$groupTitle = mysqli_real_escape_string($con,$_POST['groupTitle']);
$groupDescription = mysqli_real_escape_string($con,$_POST['groupDescription']);
$groupImage=$_FILES['groupImage'];
$folder_name='groupImage/';
$updatedAt=time();

if(!$userID)
{
  http_response_code(400);
  $message = array('code'=>400,'status'=>0,'message'=>'Parameter missing.');
  send_response($message);
  exit; 
}

if (!empty($lobbyID)) {
  $getData=getDataFromTable('lobbies','*',['lobbyID'=>$lobbyID],'');
  if (!empty($_FILES['groupImage']['name'])) 
  {
             
    if(!is_dir($folder_name))
    {

      mkdir($folder_name);

    }

    $uniquesavename1=uniqid();
    $uniquesavename=$folder_name.$uniquesavename1.'.png';
    unlink($getData[0]['groupImage']);
    $file_tmp= $_FILES['groupImage']['tmp_name'];
    move_uploaded_file($file_tmp, $uniquesavename); 
       
  }else
  {
    $uniquesavename=$getData[0]['groupImage'];
  }


  $update=updateDataTable('lobbies',['userID'=>$userID, 'lobbyID'=>$lobbyID],['groupTitle'=>$groupTitle, 'groupDescription'=>$groupDescription, 'groupImage'=>$uniquesavename, 'updatedAt'=>$updatedAt]);
  if($update)
  {

    $lobbyDetails = getDataFromTable('lobbies','*',['lobbyID'=>$lobbyID],'')[0];
    http_response_code(200);
    $message =array('code'=>200,'status'=>1,'message'=>'updated successfully','data'=>$lobbyDetails);
    send_response($message);
    exit; 
             
  }else
  {
    http_response_code(400);
    $message =array('code'=>400,'status'=>0,'message'=>'something wents wrong');
    send_response($message);
    exit;
  }
}else{

  if (!empty($_FILES['groupImage']['name'])) 
  {
             
    if(!is_dir($folder_name))
    {

      mkdir($folder_name);

    }

    $uniquesavename1=uniqid();
    $uniquesavename=$folder_name.$uniquesavename1.'.png';
    $file_tmp= $_FILES['groupImage']['tmp_name'];
    move_uploaded_file($file_tmp, $uniquesavename); 
       
  }else
  {
    $uniquesavename="";
  }

  $insert=insertDataTable('lobbies',['userID'=>$userID,'groupTitle'=>$groupTitle, 'groupDescription'=>$groupDescription, 'groupImage'=>$uniquesavename, 'created'=>$updatedAt]);
  if($insert)
  {
    // $insertUser=insertDataTable('lobbyusers',['userID'=>$userID,'lobbyID'=>$insert, 'created'=>$updatedAt]);

    $lobbyDetails = getDataFromTable('lobbies','*',['lobbyID'=>$insert],'')[0];
    http_response_code(200);
    $message =array('code'=>200,'status'=>1,'message'=>'Lobby created successfully','data'=>$lobbyDetails);
    send_response($message);
    exit; 
             
  }else
  {
    http_response_code(400);
    $message =array('code'=>400,'status'=>0,'message'=>'something wents wrong');
    send_response($message);
    exit;
  }
}

?>