<?php
include 'Functions.php';

header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');

// $data=json_decode(file_get_contents("php://input"),true);
$header = apache_request_headers(); 

if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
  send_response($message);
  exit;  

}

require_once('vendorStripe/autoload.php');

if(empty($_POST['userName']) || empty($_POST['cardNumber'])){
  http_response_code(400);
  $message = array('code'=>400,'status'=>0,'message'=>"Parameters are missing.".mysqli_error($conn));
  send_response($message);
  exit; 
}

$userID = $TokenExist[0]['userID'];
$cardToken = $_POST['cardToken'];
// $cardID = $_POST['cardID'];
$userName = $_POST['userName'];
$cardNumber= $_POST['cardNumber'];
$cvv= $_POST['cvv'];
$expiryMonth= $_POST['expiryMonth'];
$expiryYear= $_POST['expiryYear'];
$created = time();
// print_r($_POST); die;
$where = ['userID'=>$userID];
$existDetails = getDataFromTable('users','*',$where,'')[0];
if(empty($existDetails)){

  http_response_code(400);
  $message = array('code'=>400,'status'=>0,'message'=>"This user does not exist.");
  send_response($message);
  exit; 

}

$customerId = $existDetails['customerId'];

// Stripe Authentication 
$stripe = new \Stripe\StripeClient($stripe['secret_key']);

if(empty($customerId)){
// Create a customer
  try{

    $customer = $stripe->customers->create([
        // 'description' => 'My First Test Customer (created for API docs at https://www.stripe.com/docs/api)',
        "email" => $existDetails['email'],
        "description" => 'Customer for '.$existDetails['email'],
    ]);
    // echo json_encode($customer);
    // exit();
  }catch (\Stripe\Error\Base $e) {
      // Code to do something with the $e exception object when an error occurs
      $json = array('status'=>205,
        'success' => 'error',
        'message'=>$e->getMessage()
      );
      echo json_encode($json);exit();
  } catch (Exception $e) {
      // Catch any other non-Stripe exceptions
      $json = array('status'=>206,
        'success' => 'error',
        'message'=>$e->getMessage()
      );
      echo json_encode($json);exit();
  }
  $customerId=$customer['id'];

    $data=['customerId'=>$customerId];
    $updatecustomerIdByuserID=updateDataTable('users',$where,$data);
}

// create card token 
try{
    $cardToken = $stripe->tokens->create([
    'card' => [
      // 'number' => '4242424242424242',
      // 'exp_month' => 10,
      // 'exp_year' => 2023,
      // 'cvc' => '314',
      'number' => $cardNumber,
        'exp_month' => $expiryMonth,
        'exp_year' => $expiryYear,
        'cvc' => $cvv,
    ],
  ]);
    // echo json_encode($cardToken);
    // exit();
}catch (\Stripe\Error\Base $e) {
    // Code to do something with the $e exception object when an error occurs
    $json = array('status'=>205,
      'success' => 'error',
      'message'=>$e->getMessage()
    );
    echo json_encode($json);exit();
} catch (Exception $e) {
    // Catch any other non-Stripe exceptions
    $json = array('status'=>206,
      'success' => 'error',
      'message'=>$e->getMessage()
    );
    echo json_encode($json);exit();
}

$stripeToken=$cardToken->id;

$message = array('code'=>200,'status'=>1,'message'=>'Token crteated Successfully.','token'=>$stripeToken);
  send_response($message);
  exit;

?>