<?php
// ini_set('display_errors', '1');
// ini_set('display_startup_errors', '1');
// error_reporting(E_ALL);
include 'Functions.php';

header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');

$data=json_decode(file_get_contents("php://input"),true);
$header = apache_request_headers(); 
// print_r($header);die;
if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
  send_response($message);
  exit;  

}



$userID=$TokenExist[0]['userID'];
$eventID=$data['eventID'];
$created=time();
if(empty($eventID))
{

	http_response_code(400);
	$message = array('code'=>400,'status'=>'0','message'=>'parameter missing.');
	send_response($message);
	exit;

}

$get_data=getDataFromTable('event','*',['eventID'=>$eventID],'')[0];
$venueID=$get_data['venueID'];


$getTicketsInBookingForEvent=getTicketsInBookingForEvent($venueID,$eventID);
// print_r($getTicketsInBookingForEvent);

$update= updateDataTable('event',['venueID'=>$venueID,'eventID'=>$eventID,'disable'=>0],['disable'=>1,'updatedAt'=>$created]);

foreach ($getTicketsInBookingForEvent as $value) {
  // print_r($value['ticketID']);
  if(!empty($value['ticketCatId']))
  {
    $getSubCategoryTicketsForEvent=getSubCategoryTicketsForEvent($venueID,$value['ticketCatId']);
  }

  
  $update= updateDataTable('eventvenuebooking',['venueID'=>$venueID,'eventID'=>$eventID,'isReserve'=>1,'isPurchased'=>0,'disable'=>0,'ticketID'=>$value['ticketID']],['disable'=>1,'updatedAt'=>$created]);
   // $update= updateDataTable('venueticketsV2',['ticketID'=>$value['ticketID'],'disable'=>0],['disable'=>1,'updatedAt'=>$created]);
  if($update)
  {
    if(!empty($value['ticketCatId']))
    {
      if(!empty($getSubCategoryTicketsForEvent[0]['venueTicketCatId']))
      {
        if($getSubCategoryForDeleteUser[0]['venueTicketCatId']==$value['ticketCatId'])
        {
          $update= updateDataTable('venueticketcategory',['venueID'=>$venueID,'venueTicketCatId'=>$getSubCategoryTicketsForEvent[0]['venueTicketCatId']],['disable'=>1,'updatedAt'=>$created]);
        }
      }
    }
    
  }
}


http_response_code(200);
$message = array('code'=>200,'status'=>1,'message'=>"Event delete Successfully.");
send_response($message);
// exit;



function getTicketsInBookingForEvent($venueID,$eventID)
{
	global $con;
	global $config;
	$array=array();

  $query="SELECT ticketID 
        FROM eventvenuebooking 
        WHERE 
            venueID = $venueID 
            AND eventID = $eventID 
            AND isPurchased = 0 
            AND isReserve = 1 AND ticketID NOT IN (SELECT ticketID 
        FROM eventvenuebooking 
        WHERE 
            venueID = $venueID 
            AND eventID = $eventID 
            AND isPurchased = 1 
            AND isReserve = 1 )";

	// print_r($query);
	$run = $con->query($query);
	while($result = $run->fetch_assoc())
	{		
		$result['ticketID']=$result['ticketID'];
		array_push($array, $result);

	}
	return $array;
}



function getSubCategoryTicketsForEvent($venueID,$venueTicketCatId)
{
  global $con;
  global $config;
  $array=array();

   $query="SELECT * FROM venueticketcategory WHERE venueID = $venueID AND venueTicketCatId = $venueTicketCatId ";
   // print_r($query);
    
  $run = $con->query($query);
  while($result = $run->fetch_assoc())
  {

    $result['venueTicketCatId']=$result['venueTicketCatId'];
    array_push($array, $result);

  }
  return $array;
}


?>