<?php
// ini_set('display_errors', '1');
// ini_set('display_startup_errors', '1');
// error_reporting(E_ALL);

include 'Functions.php';

header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');
$data=json_decode(file_get_contents("php://input"),true);
$header = apache_request_headers(); 

if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
  send_response($message);
  exit;  

}



$userID=$TokenExist[0]['userID'];
$venueID=$_POST['venueID'];
$created=time();



$getTicketsInBooking=getTicketsInBooking($venueID);



foreach ($getTicketsInBooking as $value) {

  $getSubCategoryTicket=getSubCategoryTickets($venueID,$value['ticketCatId']);

	
	$update= updateDataTable('venuetickets',['ticketID'=>$value['ticketID']],['disable'=>1,'updatedAt'=>$created]);
	if($update)
	{

    if(!empty($getSubCategoryTicket[0]['venueTicketCatId']))
    {
      if($getSubCategoryForDeleteUser[0]['venueTicketCatId']==$value['ticketCatId'])
      {
        $update= updateDataTable('venueticketcategory',['venueID'=>$venueID,'venueTicketCatId'=>$getSubCategoryTicket[0]['venueTicketCatId']],['disable'=>1,'updatedAt'=>$created]);
      }
    }

		$update= updateDataTable('venue',['venueID'=>$venueID,'disable'=>0],['disable'=>1,'updatedAt'=>$created]);
    $delete=deleteDataTable('venueimage',['venueID'=>$venueID]);		
	}
}

http_response_code(200);
$message = array('code'=>200,'status'=>1,'message'=>"Delete Venue Successfully.");
send_response($message);
// exit;




function getTicketsInBooking($venueID)
{
	global $con;
	global $config;
	$array=array();

	$query="SELECT * FROM venuetickets WHERE venueID = $venueID AND disable = 0 
    AND ticketID NOT IN (
        SELECT ticketID 
        FROM eventvenuebooking 
        WHERE disable=0 AND venueID = $venueID AND isPurchased=1)";
        // print_r($query);
    
	
	$run = $con->query($query);
	while($result = $run->fetch_assoc())
	{		
		$result['ticketID']=$result['ticketID'];
		array_push($array, $result);

	}
	return $array;
}



function getSubCategoryTickets($venueID,$venueTicketCatId)
{
  global $con;
  global $config;
  $array=array();

   $query="SELECT * FROM venueticketcategory WHERE venueID = $venueID AND venueTicketCatId = $venueTicketCatId ";
   // print_r($query);
    
  $run = $con->query($query);
  while($result = $run->fetch_assoc())
  {

    $result['venueTicketCatId']=$result['venueTicketCatId'];
    array_push($array, $result);

  }
  return $array;
}


?>