<?php
header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');
include 'Functions.php';

$header = apache_request_headers(); 
if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
  send_response($message);
  exit;  

}

$userID=$TokenExist[0]['userID'];

$firstName = mysqli_real_escape_string($con,$_POST['firstName']);
$lastName = mysqli_real_escape_string($con,$_POST['lastName']);
$userName = mysqli_real_escape_string($con,$_POST['userName']);
$age=$_POST['age'];
$idNumber=$_POST['idNumber'];
$address = mysqli_real_escape_string($con,$_POST['address']);
$state=$_POST['state'];
$country=$_POST['country'];
$city=$_POST['city'];
$dob=$_POST['dob']; 
$gender=$_POST['gender']; 
$updatedAt=time();
$profileImage=$_FILES['profileImage'];
$companyLogo=$_FILES['companyLogo'];
$folder_name='profileImage/';
$folder_name1='companyLogo/';

if(!$userID)
{
  http_response_code(400);
  $message = array('code'=>400,'status'=>0,'message'=>'Parameter missing.');
  send_response($message);
  exit; 
}

$getData=getDataFromTable('users','*',['userID'=>$userID],'');
if (!empty($_FILES['profileImage']['name'])) 
{      
  if(!is_dir($folder_name))
  {
    mkdir($folder_name,0777,true);
  }

  $uniquesavename1=uniqid();
  $uniquesavename=$folder_name.$uniquesavename1.'.png';
  unlink($getData[0]['profileImage']);
  $file_tmp= $_FILES['profileImage']['tmp_name'];
  move_uploaded_file($file_tmp, $uniquesavename); 

     
}else
{
  $uniquesavename=$getData[0]['profileImage'];
}


if (!empty($_FILES['companyLogo']['name'])) 
{      
  if(!is_dir($folder_name1))
  {
    mkdir($folder_name1,0777,true);
  }

  $uniquesavename1=uniqid();
  $uniqueCompanyLogo=$folder_name1.$uniquesavename1.'.png';
  unlink($getData[0]['companyLogo']);
  $file_tmp= $_FILES['companyLogo']['tmp_name'];
  move_uploaded_file($file_tmp, $uniqueCompanyLogo); 

     
}else
{
  $uniqueCompanyLogo=$getData[0]['companyLogo'];
}

$checkUserNameExists=getDataFromTable('users','*',['userName'=>$userName],' AND userID!='.$userID);

if (!empty($checkUserNameExists)) {
http_response_code(400);
$message = array('code'=>400,'status'=>0,'message'=>"This username is already exist.");
send_response($message);
exit;
}

$checkIdNumberExists=getDataFromTable('users','*',['idNumber'=>$idNumber],' AND userID!='.$userID);
// print_r($checkIdNumberExists);
if (!empty($checkIdNumberExists)) {
http_response_code(400);
$message = array('code'=>400,'status'=>0,'message'=>"This ID Number is already exist.");
send_response($message);
exit;
}


$update=updateDataTable('users',['userID'=>$userID],['firstName'=>$firstName, 'lastName'=>$lastName, 'userName'=>$userName, 'updatedAt'=>$updatedAt,  'age'=>$age, 'gender'=>$gender,'idNumber'=>$idNumber,'state'=>$state, 'country'=>$country, 'address'=>$address, 'city'=>$city, 'dob'=>$dob,'profileImage'=>$uniquesavename,'companyLogo'=>$uniqueCompanyLogo]);

if($update)
{

  $userDetails =getUserData($userID,0,0);
  $userDetails['authToken'] = $token;

  http_response_code(200);
  $message =array('code'=>200,'status'=>1,'message'=>'Profile updated successfully','data'=>$userDetails);
  send_response($message);
  exit; 
           
}else
{
  http_response_code(400);
  $message =array('code'=>400,'status'=>0,'message'=>'Something wents wrong');
  send_response($message);
  exit;
}
?>