<?php
include 'Functions.php';

header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');

$data=json_decode(file_get_contents("php://input"),true);
$header = apache_request_headers(); 

if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
  send_response($message);
  exit;  

}

$userID = $TokenExist[0]['userID'];

if(!$userID)
{
  http_response_code(400);
  $message = array('code'=>400,'status'=>0,'message'=>"Parameter missing.");
  send_response($message);
  exit;
}

$get_data=getDataFromTable('users','*',['userID'=>$userID,'isDeleted'=>0],'');

if(!empty($get_data))
{
  if($get_data[0]['disable']==1)
  {
    http_response_code(400);
    $message = array('code'=>400,"status"=>0,"message"=> "your account disabled, please contact to support.");
    send_response($message);
    exit; 
  }

}

// $getBookingList = getEventBookingListDataFromTable('purchaseeventticket','*',['paidByUser'=>$userID],'');
$getBookingList = getEventBookingListDataFromTable('purchaseeventticket','event','inner join','event.*,purchaseeventticket.ticketNo','purchaseeventticket.eventID=event.eventID',['purchaseeventticket.paidByUser'=>$userID],'order by dateAndTime asc');
// $getMyEventListing=getMyEvents($userID);
if($getBookingList)
{
  http_response_code(200);
  $message =array('code'=>200,"status"=>1,"message"=>"Get Booking event list ",'data'=>$getBookingList);
  send_response($message);
  exit; 
}
else
{

  http_response_code(404);
  $message = array('code'=>404, "status" => 0, "message" => "No data found.". $con->error);
  send_response($message);
  exit;

}

function getEventBookingListDataFromTable($table_name,$table_name2,$join,$get,$on,$where,$order_by)
{
  
  if(!empty($where))
  {
       foreach ($where as $key => $value) {
         $whereQuery[] = ' '.$key."='".$value."'";
      }

      $where = implode('AND ',$whereQuery);
      $where = "WHERE ".$where;
  }
  
  global $con;
  global $config;
  $q['query'] = "SELECT $get FROM $table_name $join $table_name2 on $on $where $order_by ";
  // print_r($q['query']);
  $q['run'] = $con->query($q['query']);
  $q['result'] = array();
  while($c=$q['run']->fetch_assoc())
  {   
    if (!empty($c['eventImage'])) {
      $c['eventImage']=$config['base_url'].$c['eventImage'];
    }
    else
    {
      $c['eventImage']="";  
    }

    if (!empty($c['hostImage'])) {
      $c['hostImage']=$config['base_url'].$c['hostImage'];
    }
    else
    {
      $c['hostImage']=""; 
    }
    array_push($q['result'], $c);
  }

  return $q['result'];

}

?>