<?php
include 'Functions.php';

header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');
$data=json_decode(file_get_contents("php://input"),true);
$header = apache_request_headers(); 

if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
  send_response($message);
  exit;  

}

$userID = $TokenExist[0]['userID'];
$eventID = $data['eventID'];
$created = time();

if(!$userID  || !$eventID)
{
  http_response_code(400);
  $message = array('code'=>400,'status'=>0,'message'=>"Parameters missing.");
  send_response($message);
  exit;
}

$favEventExist=getDataFromTable('favevent','*',['userID'=>$userID, 'eventID'=>$eventID],'');
if(empty($favEventExist))
{

  $insert=insertDataTable('favevent',['userID'=>$userID,'eventID'=>$eventID,'isfav'=>1,'created'=>$created]);

  if($insert)
  {

    // $userDetails=getDataFromTable('users','*',['userID'=>$userID],'')[0];
    // $eventDetails=getDataFromTable('event','*',['eventID'=>$eventID],'')[0];

    // $notificationMessage = $userDetails['userName'];
    // $message = "favorite your event.";
  
    // $notificationData = insertDataTable('notification',['title'=>$notificationMessage,'description'=>$message,'notificationType'=>11,'userID'=>$eventDetails['userID'],'otherUserID'=>$userID,'detailsID'=>$eventID,'created'=>$created]);

    // $where=['notificationID'=>$notificationData];
    // $notificationDetails =getDataFromTable('notification','*',$where,'')[0];
    
    // $notificationUser=getDataFromTable('usertoken','*',['userID'=>$notificationDetails['userID']],'');
    // foreach ($notificationUser as $key1 => $valueUser) {
    //   if($valueUser['deviceType'] == 1) {
    //     $push_notification = sendpush_android($notificationMessage,$message, $valueUser['deviceToken'], $notificationDetails);
    //   }
    //   if($valueUser['deviceType'] == 2) {
    //     $push_notification = send_push_IOS_By_p8($notificationMessage,$message,$valueUser['deviceToken'],$notificationDetails,0);
    //   }
    // }

    http_response_code(200);
    $message =array('code'=>200,"status"=>1,'isfav'=>1,"message"=>"Event favorite successfully");
    send_response($message);
    exit; 
  }
  else
  {

    http_response_code(400);
    $message = array('code'=>400, "status" => 0, "message" => "Something went wrong");
    send_response($message);
    exit;

  }

}
else
{

  $delete = deleteDataTable('favevent',['favID'=>$favEventExist[0]['favID']]);

  if($delete)
  {
    http_response_code(200);
    $message =array('code'=>200,"status"=>1,'isfav'=>0,"message"=>"Event unfavorite");
    send_response($message);
    exit; 
  }
  else
  {
    http_response_code(400);
    $message = array('code'=>400, "status" => 0, "message" => "Something went wrong");
    send_response($message);
    exit;

  }

}

?>