<?php
// ini_set('display_errors', '1');
// ini_set('display_startup_errors', '1');
// error_reporting(E_ALL);

include 'Functions.php';
require_once('vendorStripe/autoload.php');

header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');
$data=json_decode(file_get_contents("php://input"),true);
$header = apache_request_headers(); 

if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
	http_response_code(401);
	$message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
	send_response($message);
	exit;  

}


$userID=$TokenExist[0]['userID'];
$perpage = $_POST['perpage']?$_POST['perpage']:10; // get per page data limit
$pagenumber = $_POST['pagenumber']?$_POST['pagenumber']:1; //get page no
$offset = ($pagenumber - 1) * $perpage;

$getAllFeaturedVenue=getAllFeaturedVenue($userID,$perpage,$offset);
if($getAllFeaturedVenue)
{
	http_response_code(200);
    $message=array('code'=>200,'status'=>1,'message' =>'Get All Featured Venue.','data'=>$getAllFeaturedVenue);
	send_response($message);
}else
{
	http_response_code(400);
    $message=array('code'=>400,'status'=>1,'message' =>'No data found.','data'=>[]);
	send_response($message);
}


function getAllFeaturedVenue($userID,$perpage,$offset)
{
	global $con;
	global $config;
	$array=array();

	$query="SELECT venue.*, COUNT(eventvenuebooking.venueID) AS total_bookings
	FROM venue 
	LEFT JOIN eventvenuebooking ON venue.venueID = eventvenuebooking.venueID
	WHERE eventvenuebooking.isPurchased=1 OR eventvenuebooking.isPurchased IS NULL
	GROUP BY venue.venueID
	ORDER BY total_bookings DESC LIMIT $perpage OFFSET $offset";
	// ORDER BY total_bookings DESC, venue.venueID DESC";

	$run = $con->query($query);
	while($result = $run->fetch_assoc())
	{
		if (!empty($result['parkingImage'])) {       

      		$result['parkingImage']=$config['base_url'].'venue/barCodeImage/'.$result['parkingImage'];
        }
      	else
      	{
      		$result['parkingImage']="";
      	}


      	if (!empty($result['layoutImage'])) {
         
      		$result['layoutImage']=$config['base_url'].'venue/layoutImage/'.$result['layoutImage'];
      	}
      	else
      	{
        	$result['layoutImage']="";
      	}

		$venueImg=getVenueImages($result['venueID'],"0");
		if($venueImg)
      	{
        	$result['venueImg']=$venueImg;
      	}else
      	{
        	$result['venueImg']=[];
      	}
		array_push($array, $result);
	}
	return $array;
}







?>