<?php
// ini_set('display_errors', '1');
// ini_set('display_startup_errors', '1');
// error_reporting(E_ALL);

include 'Functions.php';
require_once('vendorStripe/autoload.php');

header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');
$data=json_decode(file_get_contents("php://input"),true);
$header = apache_request_headers(); 

if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
	http_response_code(401);
	$message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
	send_response($message);
	exit;  

}

$userID=$TokenExist[0]['userID'];
$perpage = $_POST['perpage']?$_POST['perpage']:10; // get per page data limit
$pagenumber = $_POST['pagenumber']?$_POST['pagenumber']:1; //get page no
$offset = ($pagenumber - 1) * $perpage;



function getAllPopularEvents()
{
	global $con;
	global $config;
	$array=array();

	$query="SELECT event.*, COUNT(eventvenuebooking.eventID) AS total_bookings
	FROM event 
	LEFT JOIN eventvenuebooking ON event.eventID = eventvenuebooking.eventID
	WHERE eventvenuebooking.isPurchased=1 OR eventvenuebooking.isPurchased IS NULL
	GROUP BY event.eventID
	ORDER BY total_bookings DESC, event.eventID DESC";

	$run = $con->query($query);
	while($result = $run->fetch_assoc())
	{
    if (!empty($result['eventImage'])) {
         

      $result['eventImage']=$config['base_url'].$result['eventImage'];


      }
      else
      {
        $result['eventImage']="";
      }


      if (!empty($result['hostImage'])) {
         

      $result['hostImage']=$config['base_url'].$result['hostImage'];

      }
      else
      {
          $result['hostImage']="";
      }
		array_push($array, $result);
	}
	return $array;
}




?>