<?php
// ini_set('display_errors', '1');
// ini_set('display_startup_errors', '1');
// error_reporting(E_ALL);
include 'Functions.php';
header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');
$header = apache_request_headers(); 

$data=json_decode(file_get_contents("php://input"),true);

if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
  send_response($message);
  exit;  

}

$userID=$TokenExist[0]['userID'];
$eventID=$data["eventID"];
$venueID=$data["venueID"];
$categoryID=$data['categoryID'];
$perpage = $data['perpage']?$data['perpage']:10; // get per page data limit
$pagenumber = $data['pagenumber']?$data['pagenumber']:1; //get page no
$offset = ($pagenumber - 1) * $perpage;


$getEventDetail =getDataFromTableWithImages('event','*',['eventID'=>$eventID,'venueID'=>$venueID,'disable'=>0],'')[0];
$eventStartDateAndTime=$getEventDetail['startDateAndTime'];
$eventEndDateAndTime=$getEventDetail['endDateAndTime'];
$eventId=$getEventDetail['eventID'];




$getCategory =getDataFromTableWithImages('eventcategory','*',['categoryID'=>$categoryID],'')[0];
if (!empty($getCategory)) {
  $categoryName = $getCategory['categoryName'];
}else{
  $categoryName = "";
}

$getVenueDetail =getVenueLayoutImage($venueID);
if (!empty($getVenueDetail)) {
  $layoutImage = $getVenueDetail['layoutImage'];
}else{
  $layoutImage = "";
}

$getEventTicketData =getDataFromTableWithImages('venuetickets','*',['venueID'=>$venueID,'categoryID'=>$categoryID,'ticketCatId'=>0],'')[0];
if (!empty($getEventTicketData)) {
  $ticketPrice=$getEventTicketData['ticketPrice'];
}else{
  $ticketPrice="";
}

$getEventTicketCount =getDataFromTableWithImages('venuetickets','count(*) as totalCount',['venueID'=>$venueID,'categoryID'=>$categoryID,'ticketCatId'=>0],'')[0];
if (!empty($getEventTicketCount)) {
  $totalCount = $getEventTicketCount['totalCount'];
}else{
  $totalCount = "0";
}

if($categoryID==4)
{
$getEventTicket=getVenueTicketListing1($venueID,$categoryID,$perpage,$offset,$eventId,$eventStartDateAndTime,$eventEndDateAndTime);
}
else
{
  $getVenueTicketCategory=getVenueTicketCategory1($venueID,$categoryID,$eventId,$eventStartDateAndTime,$eventEndDateAndTime);
}


if($categoryID==4)
{
  if($getEventTicket)
  {

    http_response_code(200);
    $message =array('code'=>200,"status"=>1,"message"=>"Ticket category list.",'venueID'=>$venueID,'categoryID'=>$categoryID,'categoryName'=>$categoryName,'ticketCount'=>$totalCount,'ticketPrice'=>$ticketPrice,'parkingCost'=>$parkingCost,'serviceCost'=>$serviceCost,'layoutImage'=>$layoutImage, "houseParty"=>$getEventTicket,'others'=>[]);
    send_response($message);
    exit; 

  }
  else
  {

    http_response_code(400);
    $message =array('code'=>400,"status"=>0,"message"=>"No data found",'venueID'=>$venueID,'categoryID'=>$categoryID,'categoryName'=>$categoryName,'ticketCount'=>$totalCount,'ticketPrice'=>$ticketPrice, 'parkingCost'=>$parkingCost, 'serviceCost'=>$serviceCost,'layoutImage'=>$layoutImage, "houseParty"=>$getEventTicket,'others'=>[]);
    send_response($message);

  }
}
else
{
    if($getVenueTicketCategory)
  {

    http_response_code(200);
    $message =array('code'=>200,"status"=>1,"message"=>"Ticket category list.",'venueID'=>$venueID,'categoryID'=>$categoryID,'categoryName'=>$categoryName,'ticketCount'=>$totalCount,'ticketPrice'=>$ticketPrice,'parkingCost'=>$parkingCost,'serviceCost'=>$serviceCost,'layoutImage'=>$layoutImage, "houseParty"=>[],'others'=>$getVenueTicketCategory);
    send_response($message);
    exit; 

  }
  else
  {

    http_response_code(400);
    $message =array('code'=>400,"status"=>0,"message"=>"No data found",'venueID'=>$venueID,'categoryID'=>$categoryID,'categoryName'=>$categoryName,'ticketCount'=>$totalCount,'ticketPrice'=>$ticketPrice, 'parkingCost'=>$parkingCost, 'serviceCost'=>$serviceCost,'layoutImage'=>$layoutImage, "houseParty"=>[],'others'=>$getVenueTicketCategory);
    send_response($message);

  }
}







?>