<?php
include 'Functions.php';

header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');

$data=json_decode(file_get_contents("php://input"),true);
$header = apache_request_headers(); 
if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
  send_response($message);
  exit;  

}

$userID=$TokenExist[0]['userID'];
// print_r($userID);
$perpage=$data['perpage'];
$pagenumber=$data['pagenumber'];
$offset=($pagenumber-1)*$perpage;
$get_data=getDataFromTable('users','*',['userID'=>$userID,'isDeleted'=>0],'');

if(!empty($get_data))
{
  if($get_data[0]['disable']==1)
  {
    http_response_code(400);
    $message = array('code'=>400,"status"=>0,"message"=> "your account disabled, please contact to support.");
    send_response($message);
    exit; 
  }

}

$get_detail=getLobbyDataFromTableWithLobbyUser('lobbies','*',['isDisable'=>0],' order by created desc LIMIT '. $perpage .' OFFSET '.$offset,$userID);
if($get_detail){

  http_response_code(200);
  $message =array('code'=>200,"status"=>1,"message"=>"Get lobbies listing", "data"=>$get_detail);
  send_response($message);
  exit;
}
else{
  http_response_code(400);
  $message = array('code'=>400, "status" => 0, "message" => "No Data Found ");
  send_response($message);
  exit;  
}




?>