<?php
include 'Functions.php';

header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');

$data=json_decode(file_get_contents("php://input"),true);
$header = apache_request_headers(); 
if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
  send_response($message);
  exit;  

}

$userID=$TokenExist[0]['userID'];
$perpage=$data['perpage'];
$pagenumber=$data['pagenumber'];
$offset=($pagenumber-1)*$perpage;
$updateReadStatus= updateDataTable('notification',['notificationReadStatus'=>0],['notificationReadStatus'=>1]);
$get_detail=get_detail_from_table_user_for_pagination('*','notification',$userID,$perpage,$offset);
if($get_detail){

  http_response_code(200);
  $message =array('code'=>200,"status"=>1,"message"=>"Get notification listing", "data"=>$get_detail);
  send_response($message);
  exit;
}
else{
  http_response_code(400);
  $message = array('code'=>400, "status" => 0, "message" => "No Data Found ");
  send_response($message);
  exit;  
}




?>