<?php
// ini_set('display_errors', '1');
// ini_set('display_startup_errors', '1');
// error_reporting(E_ALL);
header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');
$data=json_decode(file_get_contents("php://input"),true);
include 'Functions.php';

$header = apache_request_headers(); 
if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
  send_response($message);
  exit;  

}


$otherUserID=$data["otherUserID"];
$userID=$TokenExist[0]['userID'];

$get_data=getDataFromTable('users','*',['userID'=>$userID,'isDeleted'=>0],'');

if(!empty($get_data))
{
  if($get_data[0]['disable']==1)
  {
    http_response_code(400);
    $message = array('code'=>400,"status"=>0,"message"=> "your account disabled, please contact to support.");
    send_response($message);
    exit; 
  }

}
if(!$otherUserID)
{

  http_response_code(400);
  $message = array('code'=>400,'status'=>0,'message'=>"Parameters missing");
  send_response($message);
  exit; 

}

$getProfileDetails=getUserDataWithRatingV2($userID,$otherUserID,0);
// $getProfileDetails=getUserData(0,$otherUserID,0);
// $eventImg=eventImage($otherUserID);
$eventImg=MyEventImage($userID,$otherUserID);


$getProfileDetails['roomID']="";
if($getProfileDetails)
{

  http_response_code(200);
  $message =array('code'=>200,"status"=>1,"message"=>"get other user profile details ",'data'=>$getProfileDetails,'eventImages'=>$eventImg);
  send_response($message);
  exit; 
          
}
else
{

  http_response_code(400);
  $message = array('code'=>400, "status" => 0, "message" => "Something went wrong");
  send_response($message);
  exit;

}

function MyEventImage($userID,$otherUserID)
{

  global $con;
  global $config;
  $array=array();
  $created = time();
  if ($userID == $otherUserID) {
    $query="SELECT * FROM event WHERE disable=0 AND EndDateAndTime>=$created AND userID = $otherUserID ORDER BY EndDateAndTime ASC";
  }else{
    $UserDetails =getDataFromTable('users','*',['userID'=>$userID],'')[0];
    if ($UserDetails['age']>21) {
      $query="SELECT * FROM event WHERE disable=0 AND EndDateAndTime>=$created AND( forAdults=0 OR forAdults=1) AND userID=$otherUserID AND (eventType= 0 OR (eventType = 1 and ( userID IN(SELECT otherUserID FROM favusers where status =2 and userID = $userID)))) ORDER BY EndDateAndTime ASC";

      // OR userID IN(SELECT userID FROM favusers where status =2 and otherUserID = $otherUserID )
    // print_r($query);  
    }else{
      $query="SELECT * FROM event WHERE disable=0 AND EndDateAndTime>=$created AND forAdults=0 AND userID=$otherUserID AND (eventType= 0 OR (eventType = 1 and ( userID IN(SELECT otherUserID FROM favusers where status =2 and userID = $userID)))) ORDER BY EndDateAndTime ASC";

      // OR userID IN(SELECT userID FROM favusers where status =2 and otherUserID = $otherUserID )
    // print_r($query);  
    }

  }
  

  $run = $con->query($query);
  while($result = $run->fetch_assoc())
  {

    if (!empty($result['eventImage'])) {
      $result['eventImage']=$config['base_url'].$result['eventImage'];
    }
    else
    {
      $result['eventImage']="";
    }

    array_push($array, $result);

  }

  return $array;

}


function getUserDataWithRatingV2($userID,$otherUserID,$roleType)
{

  global $con;
  global $config;

  $query = "SELECT * FROM users WHERE userID=$otherUserID";
  // print_r($query);die();
  $run = $con->query($query);

  $result = $run->fetch_assoc();

  $where = "userID=$userID and otherUserID =$otherUserID";
  $getIsFav=getDataFromTableWithStaticWhere('favusers','*',$where,'');
  // print_r($getIsFav[0]);
  // $getIsFav=getDataFromTable('favusers','*',['otherUserID'=>$otherUserID],'');
  if($getIsFav)
  {
    if ( $getIsFav[0]['status']==1) {
      // $result['isFriend']="0";
      $result['isFriend']=$getIsFav[0]['status'];
    }else if ( $getIsFav[0]['status']==2) {
      // $result['isFriend']="0";
      $result['isFriend']=$getIsFav[0]['status'];
    }
    else{
      $result['isFriend']="0";
    }
  }
  else
  {
    $result['isFriend']="0";
  }
  $getCount = getDataFromTable('userrating','round(AVG(isRating),1) as isRating',['ratingToOtherID'=>$result['userID']],'')[0];
  $result['isRating'] = $getCount['isRating'];
  if(!empty($result['profileImage']))
  {
    if($result['profileImage'])
    {
      if(preg_match('/http/i',$result['profileImage']))
     {
        $result['profileImage'] = $result['profileImage'];
     }
      else
      {
        $result['profileImage'] = $config['base_url'].$result['profileImage'];
      }

    }
    else
    {
      $result['profileImage'] ="";
    }

  }

  if (isset($result['avatarImage'])) {
    if(!empty($result['avatarImage']))
    {
      if(preg_match('/http/i',$result['avatarImage']))
      {
        $result['avatarImage'] = $result['avatarImage'];
      }
      else
      {
        $result['avatarImage'] = $config['base_url'].$result['avatarImage'];
      }

    }
    else
    {
      $result['avatarImage'] ="";
    }
  }

  
  return $result;

}

?>