<?php
include 'Functions.php';
header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');
$header = apache_request_headers(); 

$data=json_decode(file_get_contents("php://input"),true);

if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
  send_response($message);
  exit;  

}

$userID=$TokenExist[0]['userID'];
$eventID=$data["eventID"];
$categoryID=$data['categoryID'];

$perpage = $input['perpage']?$input['perpage']:10; // get per page data limit
$pagenumber = $input['pagenumber']?$input['pagenumber']:1; //get page no
$offset = ($pagenumber - 1) * $perpage;

$getEventTicket =getTicketListingFromTable('eventtickets','*',['eventID'=>$eventID,'categoryID'=>$categoryID,'disable'=>0],'LIMIT '.$perpage.' OFFSET '.$offset);
if($getEventTicket)
{

  http_response_code(200);
  $message =array('code'=>200,"status"=>1,"message"=>"Ticket category list.", "data"=>$getEventTicket);
  send_response($message);
  exit; 

}
else
{

  http_response_code(400);
  $message = array('code'=>400,"status" => 0, "message" => "Something went wrong");
  send_response($message);

}

function getTicketListingFromTable($table_name,$get,$where,$order_by)
{
  
  if(!empty($where))
  {
       foreach ($where as $key => $value) {
         $whereQuery[] = ' '.$key."='".$value."'";
      }

      $where = implode('AND ',$whereQuery);
      $where = "WHERE ".$where;
  }
  
  global $con;
  global $config;
  $q['query'] = "SELECT $get FROM $table_name $where $order_by "; 
  // print_r($q['query']); 
  $q['run'] = $con->query($q['query']);
  $q['result'] = array();
  while($c=$q['run']->fetch_assoc())
  {  
    if (isset($c['ticketCatId']) && !empty($c['ticketCatId'])) {
      $TicketCatDetails =getDataFromTable('eventticketcategory','*',['ticketCatId'=>$c['ticketCatId']],'')[0];
      $c['categoryName'] = $TicketCatDetails['categoryName'];
    }else{
      $c['categoryName'] = "";
    }
    if (isset($c['groupImage'])) {
      if(!empty($c['groupImage']))
      {
        if(preg_match('/http/i',$c['groupImage']))
        {
          $c['groupImage'] = $c['groupImage'];
        }
        else
        {
          $c['groupImage'] = $config['base_url'].$c['groupImage'];
        }
  
      }
      else
      {
        $c['groupImage'] ="";
      }
    }
    if (isset($c['avatarImage'])) {
      if(!empty($c['avatarImage']))
      {
        if(preg_match('/http/i',$c['avatarImage']))
        {
          $c['avatarImage'] = $c['avatarImage'];
        }
        else
        {
          $c['avatarImage'] = $config['base_url'].$c['avatarImage'];
        }
  
      }
      else
      {
        $c['avatarImage'] ="";
      }
    }

    if (isset($c['ticketImage'])) {
      if(!empty($c['ticketImage']))
      {
        if(preg_match('/http/i',$c['ticketImage']))
        {
          $c['ticketImage'] = $c['ticketImage'];
        }
        else
        {
          $c['ticketImage'] = $config['base_url'].$c['ticketImage'];
        }
  
      }
      else
      {
        $c['ticketImage'] ="";
      }
    }
    array_push($q['result'], $c);
  }

  return $q['result'];

}

?>