<?php
include 'Functions.php';
header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');
$header = apache_request_headers(); 

$data=json_decode(file_get_contents("php://input"),true);

if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
  send_response($message);
  exit;  

}

$userID=$TokenExist[0]['userID'];
$eventID=$data["eventID"];
$categoryID=$data['categoryID'];

$perpage = $data['perpage']?$data['perpage']:10; // get per page data limit
$pagenumber = $data['pagenumber']?$data['pagenumber']:1; //get page no
$offset = ($pagenumber - 1) * $perpage;

$getEvent =getDataFromTableWithImages('event','*',['eventID'=>$eventID],'')[0];
if (!empty($getEvent)) {
  $parkingCost = $getEvent['parkingCost'];
  $serviceCost = $getEvent['serviceCost'];
  $ticketImage = $getEvent['ticketImage'];
  $eventName = $getEvent['eventName'];
}else{
  $parkingCost = "";
  $serviceCost = "";
  $ticketImage = "";
  $eventName = "";
}
$getCategory =getDataFromTableWithImages('eventcategory','*',['categoryID'=>$categoryID],'')[0];
if (!empty($getCategory)) {
  $categoryName = $getCategory['categoryName'];
}else{
  $categoryName = "";
}


$getEventTicketData =getDataFromTableWithImages('eventtickets','*',['eventID'=>$eventID,'categoryID'=>$categoryID,'ticketCatId'=>0],'')[0];
if (!empty($getEventTicketData)) {
  $ticketPrice=$getEventTicketData['ticketPrice'];
}else{
  $ticketPrice="";
}

$getEventTicketCount =getDataFromTableWithImages('eventtickets','count(*) as totalCount',['eventID'=>$eventID,'categoryID'=>$categoryID,'ticketCatId'=>0],'')[0];
if (!empty($getEventTicketCount)) {
  $totalCount = $getEventTicketCount['totalCount'];
}else{
  $totalCount = "0";
}

$getEventTicket =getTicketListingFromTable('eventtickets','*',['eventID'=>$eventID,'categoryID'=>$categoryID,'disable'=>0],'LIMIT '.$perpage.' OFFSET '.$offset);
if($getEventTicket)
{

  http_response_code(200);
  $message =array('code'=>200,"status"=>1,"message"=>"Ticket category list.",'eventID'=>$eventID,'categoryID'=>$categoryID,'eventName'=>$eventName,'categoryName'=>$categoryName,'ticketImage'=>$ticketImage,'ticketCount'=>$totalCount,'ticketPrice'=>$ticketPrice,'parkingCost'=>$parkingCost,'serviceCost'=>$serviceCost, "data"=>$getEventTicket);
  send_response($message);
  exit; 

}
else
{

  http_response_code(400);
  $message =array('code'=>400,"status"=>0,"message"=>"No data found",'eventID'=>$eventID,'categoryID'=>$categoryID,'eventName'=>$eventName,'categoryName'=>$categoryName,'ticketImage'=>$ticketImage,'ticketCount'=>$totalCount,'ticketPrice'=>$ticketPrice, 'parkingCost'=>$parkingCost, 'serviceCost'=>$serviceCost, "data"=>$getEventTicket);
  send_response($message);

}


?>