<?php
// ini_set('display_errors', '1');
// ini_set('display_startup_errors', '1');
// error_reporting(E_ALL);
include 'Functions.php';
header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');
$header = apache_request_headers(); 

$data=json_decode(file_get_contents("php://input"),true);

if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
  send_response($message);
  exit;  

}

$type=$data['type'];   //1=>get venue tickets, 2=>get event tickets
$userID=$TokenExist[0]['userID'];
$eventID=$data["eventID"];
$venueID=$data["venueID"];
$categoryID=$data['categoryID'];
$startDateAndTime=$data['startDateAndTime'];
$endDateAndTime=$data['endDateAndTime'];
$perpage = $data['perpage']?$data['perpage']:10; // get per page data limit
$pagenumber = $data['pagenumber']?$data['pagenumber']:1; //get page no
$offset = ($pagenumber - 1) * $perpage;
$created=time();
// print_r($data);





if($type==1)
{

  $resultTime1=$startDateAndTime/1000;
  $startTime = intval($resultTime1);

  $startDate1 = date("Y-m-d",$startTime);
  // print_r($startDate1);
  $startTime1 = date("H:i:s A",$resultTime1);

 $startTime1 = preg_replace('/(?<=\d)([AP]M)/', ' $1', $startTime1); // Add space before AM/PM
$startTime1 = json_encode($startTime1); // JSON encode the modified time string


  $resultTime2=$endDateAndTime/1000;
  $EndTime = intval($resultTime2);

  $endDate1 = date("Y-m-d",$EndTime);
  // print_r($endDate1);
  $endTime1 = date("H:i:s A",$resultTime2);

  $endTime1 = preg_replace('/(?<=\d)([AP]M)/', ' $1', $endTime1); // Add space before AM/PM
  $endTime1 = json_encode($endTime1); // JSON encode the modified time string

   // $update= updateDataTable('eventvenuebooking',['cancelTicket'=>1,'venueID'=>$venueID],['disable'=>1,'updatedAt'=>$created]);

   $delete=deleteDataTable('eventvenuebooking',['cancelTicket'=>1,'venueID'=>$venueID]);


  $getCategory =getDataFromTableWithImages('eventcategory','*',['categoryID'=>$categoryID],'')[0];
  if (!empty($getCategory)) {
    $categoryName = $getCategory['categoryName'];
  }else{
    $categoryName = "";
  }

  $getVenueDetail =getVenueLayoutImage($venueID);
  if (!empty($getVenueDetail)) {
    $layoutImage = $getVenueDetail['layoutImage'];
    $serviceCost = $getVenueDetail['serviceCost'];
  }else{
    $layoutImage = "";
    $serviceCost="";
  }

  $parkingCost='0';

  $getEventTicketData =getDataFromTableWithImages('venuetickets','*',['venueID'=>$venueID,'categoryID'=>$categoryID,'ticketCatId'=>0],'')[0];
  if (!empty($getEventTicketData)) {
    $ticketPrice=$getEventTicketData['ticketPrice'];
  }else{
    $ticketPrice="";
  }

  $getEventTicketCount =getDataFromTableWithImages('venuetickets','count(*) as totalCount',['venueID'=>$venueID,'categoryID'=>$categoryID,'ticketCatId'=>0],'')[0];
  if (!empty($getEventTicketCount)) {
    $totalCount = $getEventTicketCount['totalCount'];
  }else{
    $totalCount = "0";
  }

  if($categoryID==4)
  {
  $getEventTicket=getVenueTicketListing($venueID,$startDate1,$endDate1,$startTime1,$endTime1,$categoryID,$perpage,$offset,$eventID);
  }else
  {
    $getVenueTicketCategory=getVenueTicketCategory($venueID,$categoryID,$startDate1,$endDate1,$startTime1,$endTime1,$eventID);
  }


  if($categoryID==4)
  {
    if($getEventTicket)
    {

      http_response_code(200);
      $message =array('code'=>200,"status"=>1,"message"=>"Ticket category list.",'venueID'=>$venueID,'categoryID'=>$categoryID,'categoryName'=>$categoryName,'ticketCount'=>$totalCount,'ticketPrice'=>$ticketPrice,'parkingCost'=>$parkingCost,'serviceCost'=>$serviceCost,'layoutImage'=>$layoutImage, "houseParty"=>$getEventTicket,'others'=>[]);
      send_response($message);
      exit; 

    }
    else
    {

      http_response_code(400);
      $message =array('code'=>400,"status"=>0,"message"=>"No data found",'venueID'=>$venueID,'categoryID'=>$categoryID,'categoryName'=>$categoryName,'ticketCount'=>$totalCount,'ticketPrice'=>$ticketPrice, 'parkingCost'=>$parkingCost, 'serviceCost'=>$serviceCost,'layoutImage'=>$layoutImage, "houseParty"=>$getEventTicket,'others'=>[]);
      send_response($message);

    }
  }else
  {
    if($getVenueTicketCategory)
    {

      http_response_code(200);
      $message =array('code'=>200,"status"=>1,"message"=>"Ticket category list.",'venueID'=>$venueID,'categoryID'=>$categoryID,'categoryName'=>$categoryName,'ticketCount'=>$totalCount,'ticketPrice'=>$ticketPrice,'parkingCost'=>$parkingCost,'serviceCost'=>$serviceCost,'layoutImage'=>$layoutImage, "houseParty"=>[],'others'=>$getVenueTicketCategory);
      send_response($message);
      exit; 

    }
    else
    {

      http_response_code(400);
      $message =array('code'=>400,"status"=>0,"message"=>"No data found",'venueID'=>$venueID,'categoryID'=>$categoryID,'categoryName'=>$categoryName,'ticketCount'=>$totalCount,'ticketPrice'=>$ticketPrice, 'parkingCost'=>$parkingCost, 'serviceCost'=>$serviceCost,'layoutImage'=>$layoutImage, "houseParty"=>[],'others'=>$getVenueTicketCategory);
      send_response($message);

    }
  }

}

if($type==2)
{
  $getEventDetail =getDataFromTableWithImages('event','*',['eventID'=>$eventID,'venueID'=>$venueID,'disable'=>0],'')[0];
  $eventStartDateAndTime=$getEventDetail['startDateAndTime'];
  $eventEndDateAndTime=$getEventDetail['endDateAndTime'];
  $eventId=$getEventDetail['eventID'];


  $resultTime1=$eventStartDateAndTime/1000;
  $eventStartTime = intval($resultTime1);

  $startDate1 = date("Y-m-d",$eventStartTime);
  // print_r($startDate1);
  $startTime1 = date("H:i:s A",$resultTime1);

  $startTime1 = preg_replace('/(?<=\d)([AP]M)/', ' $1', $startTime1); // Add space before AM/PM
  $startTime1 = json_encode($startTime1); // JSON encode the modified time string


  $resultTime2=$eventEndDateAndTime/1000;
  $eventEndTime = intval($resultTime2);

  $endDate1 = date("Y-m-d",$eventEndTime);
  // print_r($endDate1);
  $endTime1 = date("H:i:s A",$resultTime2);


  $endTime1 = preg_replace('/(?<=\d)([AP]M)/', ' $1', $endTime1); // Add space before AM/PM
  $endTime1 = json_encode($endTime1); // JSON encode the modified time string

  $delete=deleteDataTable('eventvenuebooking',['eventID'=>$eventID,'cancelTicket'=>1,'venueID'=>$venueID]);

  $getCategory =getDataFromTableWithImages('eventcategory','*',['categoryID'=>$categoryID],'')[0];
  if (!empty($getCategory)) {
    $categoryName = $getCategory['categoryName'];
  }else{
    $categoryName = "";
  }

  $getVenueDetail =getVenueLayoutImage($venueID);
  if (!empty($getVenueDetail)) {
    $layoutImage = $getVenueDetail['layoutImage'];
    $serviceCost = $getVenueDetail['serviceCost'];
  }else{
    $layoutImage = "";
    $serviceCost = "";
  }

  $parkingCost='0';

  $getEventTicketData =getDataFromTableWithImages('venuetickets','*',['venueID'=>$venueID,'categoryID'=>$categoryID,'ticketCatId'=>0],'')[0];
  if (!empty($getEventTicketData)) {
    $ticketPrice=$getEventTicketData['ticketPrice'];
  }else{
    $ticketPrice="";
  }

  $getEventTicketCount =getDataFromTableWithImages('venuetickets','count(*) as totalCount',['venueID'=>$venueID,'categoryID'=>$categoryID,'ticketCatId'=>0],'')[0];
  if (!empty($getEventTicketCount)) {
    $totalCount = $getEventTicketCount['totalCount'];
  }else{
    $totalCount = "0";
  }

  if($categoryID==4)
  {
  $getEventTicket=getVenueTicketListing1($venueID,$categoryID,$perpage,$offset,$eventID,$startDate1,$endDate1,$startTime1,$endTime1);
  }
  else
  {
    $getVenueTicketCategory=getVenueTicketCategory1($venueID,$categoryID,$eventID,$startDate1,$endDate1,$startTime1,$endTime1);
  }


  if($categoryID==4)
  {
    if($getEventTicket)
    {

      http_response_code(200);
      $message =array('code'=>200,"status"=>1,"message"=>"Ticket category list.",'venueID'=>$venueID,'categoryID'=>$categoryID,'categoryName'=>$categoryName,'ticketCount'=>$totalCount,'ticketPrice'=>$ticketPrice,'parkingCost'=>$parkingCost,'serviceCost'=>$serviceCost,'layoutImage'=>$layoutImage, "houseParty"=>$getEventTicket,'others'=>[]);
      send_response($message);
      exit; 

    }
    else
    {

      http_response_code(400);
      $message =array('code'=>400,"status"=>0,"message"=>"No data found",'venueID'=>$venueID,'categoryID'=>$categoryID,'categoryName'=>$categoryName,'ticketCount'=>$totalCount,'ticketPrice'=>$ticketPrice, 'parkingCost'=>$parkingCost, 'serviceCost'=>$serviceCost,'layoutImage'=>$layoutImage, "houseParty"=>$getEventTicket,'others'=>[]);
      send_response($message);

    }
  }
  else
  {
      if($getVenueTicketCategory)
    {

      http_response_code(200);
      $message =array('code'=>200,"status"=>1,"message"=>"Ticket category list.",'venueID'=>$venueID,'categoryID'=>$categoryID,'categoryName'=>$categoryName,'ticketCount'=>$totalCount,'ticketPrice'=>$ticketPrice,'parkingCost'=>$parkingCost,'serviceCost'=>$serviceCost,'layoutImage'=>$layoutImage, "houseParty"=>[],'others'=>$getVenueTicketCategory);
      send_response($message);
      exit; 

    }
    else
    {

      http_response_code(400);
      $message =array('code'=>400,"status"=>0,"message"=>"No data found",'venueID'=>$venueID,'categoryID'=>$categoryID,'categoryName'=>$categoryName,'ticketCount'=>$totalCount,'ticketPrice'=>$ticketPrice, 'parkingCost'=>$parkingCost, 'serviceCost'=>$serviceCost,'layoutImage'=>$layoutImage, "houseParty"=>[],'others'=>$getVenueTicketCategory);
      send_response($message);

    }
  }
}





?>