<?php
include 'Functions.php';
header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');

$header = apache_request_headers(); 
if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
  send_response($message);
  exit;  

}


$userID=$TokenExist[0]['userID'];
$current=strtotime(date('Y-m-d'));

$where=['userID'=>$userID];

$pagination=['LIMIT'=>'1'];

$planDetail= getDataFromTableForPage('subscription','*',$where,'ORDER BY id DESC',$pagination);

$newExpiry=$planDetail[0]['expireDate'];
// print_r($newExpiry);die();



if($current>=$newExpiry)
{
 
	$update_plan_date=updateDataTable('users',['userID'=>$userID],['isFreePlan'=>'1']);
}


$getUserDetailWithRating=getUserDetailWithRating($userID);
$popularEvents=popularEvents();
$featuredVenue=featuredVenue();
if($getUserDetailWithRating)
{
	http_response_code(200);
    $message = array('code'=>200,'status'=>1,'message'=>"Get Home Listing",'data'=>$getUserDetailWithRating,'popularEvents'=>$popularEvents,'featuredVenue'=>$featuredVenue);
    send_response($message);
    exit;
}else
{
	http_response_code(400);
    $message = array('code'=>400,'status'=>0,'message'=>"No data found",'data'=>[]);
    send_response($message);
    exit;
}


function getUserDetailWithRating($userID)
{

  global $con;
  global $config;

  $query = "SELECT * FROM users WHERE userID=$userID AND isDeleted=0";
  // print_r($query);die();
  $run = $con->query($query);

  $result = $run->fetch_assoc();

  $getCount = getDataFromTable('userrating','round(AVG(isRating),1) as isRating',['ratingToOtherID'=>$result['userID']],'')[0];
  $result['isRating'] = $getCount['isRating'];
  if(!empty($result['profileImage']))
  {
    if($result['profileImage'])
    {
      if(preg_match('/http/i',$result['profileImage']))
     {
        $result['profileImage'] = $result['profileImage'];
     }
      else
      {
        $result['profileImage'] = $config['base_url'].$result['profileImage'];
      }

    }
    else
    {
      $result['profileImage'] ="";
    }

  }

  if (isset($result['avatarImage'])) {
    if(!empty($result['avatarImage']))
    {
      if(preg_match('/http/i',$result['avatarImage']))
      {
        $result['avatarImage'] = $result['avatarImage'];
      }
      else
      {
        $result['avatarImage'] = $config['base_url'].$result['avatarImage'];
      }

    }
    else
    {
      $result['avatarImage'] ="";
    }
  }

  
  return $result;

}



function popularEvents()
{
	global $con;
	global $config;
	$array=array();

  $query="SELECT event.*, COUNT(eventvenuebooking.eventID) AS total_bookings
  FROM event
  LEFT JOIN eventvenuebooking ON event.eventID = eventvenuebooking.eventID 
  WHERE eventvenuebooking.isPurchased = 1
  AND event.disable=0
  GROUP BY event.eventID

  UNION

  SELECT event.*, 0 AS total_bookings
  FROM event
  LEFT JOIN eventvenuebooking ON event.eventID = eventvenuebooking.eventID
  WHERE event.eventID NOT IN (SELECT eventID FROM eventvenuebooking WHERE isPurchased = 1)
  AND event.disable=0 
  AND eventvenuebooking.disable=0 
  GROUP BY event.eventID

  ORDER BY total_bookings DESC
  LIMIT 5";

	// $query="SELECT event.*, COUNT(eventvenuebooking.eventID) AS total_bookings
	// FROM event 
	// LEFT JOIN eventvenuebooking ON event.eventID = eventvenuebooking.eventID
	// WHERE eventvenuebooking.isPurchased=1 OR eventvenuebooking.isPurchased IS NULL
	// GROUP BY event.eventID
	// ORDER BY total_bookings DESC LIMIT 5";
	// print_r($query);

	$run = $con->query($query);
	while($result = $run->fetch_assoc())
	{
		if (!empty($result['eventImage'])) {
         

      $result['eventImage']=$config['base_url'].$result['eventImage'];


      }
      else
      {
          $result['eventImage']="";
      }


      if (!empty($result['hostImage'])) {
         

      $result['hostImage']=$config['base_url'].$result['hostImage'];

      }
      else
      {
        $result['hostImage']="";
      }

      $catID = getDataFromTable('venue','*',['venueID'=>$result['venueID']],'')[0];
      if(!empty($catID))
      {
        $result['categoryID']=$catID['categoryID'];
      }else
      {
        $result['categoryID']='0';
      }
		array_push($array, $result);
	}
	return $array;
}



function featuredVenue()
{
	global $con;
	global $config;
	$array=array();

  $query="SELECT venue.*, COUNT(eventvenuebooking.venueID) AS total_bookings
FROM venue
LEFT JOIN eventvenuebooking ON venue.venueID = eventvenuebooking.venueID 
WHERE eventvenuebooking.isPurchased = 1
AND venue.disable=0
GROUP BY venue.venueID

UNION

SELECT venue.*, 0 AS total_bookings
FROM venue
WHERE venue.venueID NOT IN (SELECT venueID FROM eventvenuebooking WHERE isPurchased = 1) 
AND venue.disable=0
GROUP BY venue.venueID

ORDER BY total_bookings DESC
LIMIT 7";

	// $query="SELECT venue.*, COUNT(eventvenuebooking.venueID) AS total_bookings
	// FROM venue 
	// LEFT JOIN eventvenuebooking ON venue.venueID = eventvenuebooking.venueID
	// WHERE eventvenuebooking.isPurchased=1 OR eventvenuebooking.isPurchased IS NULL
	// GROUP BY venue.venueID
	// ORDER BY total_bookings DESC LIMIT 7";
	// ORDER BY total_bookings DESC, venue.venueID DESC";
  // print_r($query);

	$run = $con->query($query);
	while($result = $run->fetch_assoc())
	{
		if (!empty($result['parkingImage'])) {       

      		$result['parkingImage']=$config['base_url'].'venue/barCodeImage/'.$result['parkingImage'];
        }
      	else
      	{
      		$result['parkingImage']="";
      	}


      	if (!empty($result['layoutImage'])) {
         
      		$result['layoutImage']=$config['base_url'].'venue/layoutImage/'.$result['layoutImage'];
      	}
      	else
      	{
        	$result['layoutImage']="";
      	}

		$venueImg=getVenueImages($result['venueID'],"0");
		if($venueImg)
      	{
        	$result['venueImg']=$venueImg;
      	}else
      	{
        	$result['venueImg']=[];
      	}
		array_push($array, $result);
	}
	return $array;
}

?>