<?php

include 'Functions.php';

header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');
$data=json_decode(file_get_contents("php://input"),true);
$header = apache_request_headers(); 
if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
  send_response($message);
  exit;  

}


$type=$data["type"];
$userID=$TokenExist[0]['userID'];

if(!$userID)
{

  http_response_code(400);
  $message = array('code'=>400,'status'=>0,'message'=>"Parameters missing");
  send_response($message);
  exit; 

}


$update=updateDataTable('users',['userID'=>$userID],['interested'=>$type]);
if($update)
{
  if ($type==0) {
    $message = "User interested";
  }elseif ($type==1){
    $message = "User not interested";
  }
  http_response_code(200);
  $message =array('code'=>200,"status"=>1,'interested'=>$type,"message"=>$message);
  send_response($message);
  exit; 

}
else
{

  http_response_code(400);
  $message = array('code'=>400,"status" => 0, "message" => "Something went wrong.");
  send_response($message);

}

?>