<?php
header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');
include 'Functions.php';
$data=json_decode(file_get_contents("php://input"),true);

$header = apache_request_headers(); 
if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
  send_response($message);
  exit;  

}


$userID=$TokenExist[0]['userID'];
$eventID=$data['eventID'];
$created = time();


if(!$userID || !$eventID)
{

  http_response_code(400);
  $message = array('code'=>400,'status'=>0,'message'=>"Parameters missing.");
  send_response($message);
  exit; 
}


$interestedUserExist=getDataFromTable('interesteduser','*',['userID'=>$userID, 'eventID'=>$eventID],'');

if(!empty($interestedUserExist))
{

  deleteDataTable('interesteduser',['userID'=>$userID,'eventID'=>$eventID]);

  http_response_code(200);
  $message =array('code'=>200,"status"=>1,"message"=>"User Remove form Interested Successfully");
  send_response($message);
  exit; 

}
else
{

  $insert=insertDataTable('interesteduser',['userID'=>$userID,'eventID'=>$eventID,'created'=>$created]);

  http_response_code(200);
  $message =array('code'=>200,"status"=>1,"message"=>"User Interested Successfully");
  send_response($message);
  exit; 
}

?>