<?php
header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');
include 'Functions.php';

$header = apache_request_headers(); 
if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
  send_response($message);
  exit;  

}


$userID=$TokenExist[0]['userID'];
$lobbyID=$_POST['lobbyID'];
$updatedAt=time();

if(!$userID || !$lobbyID)
{
  http_response_code(400);
  $message = array('code'=>400,'status'=>0,'message'=>'Parameter missing.');
  send_response($message);
  exit; 
}
$getData=getDataFromTable('lobbyusers','*',['userID'=>$userID,'lobbyID'=>$lobbyID],'')[0];
if (!empty($getData)) {
  $lobbyDetails = getDataFromTable('lobbies','*',['lobbyID'=>$lobbyID],'')[0];
  if ($getData['isApproved']==1) {
    http_response_code(200);
    $message =array('code'=>200,'status'=>1,'message'=>'Already sent joining request.','data'=>$lobbyDetails);
    send_response($message);
    exit; 
  }else if ($getData['isApproved']==2) {
    http_response_code(200);
    $message =array('code'=>200,'status'=>1,'message'=>'Already joined lobby','data'=>$lobbyDetails);
    send_response($message);
    exit; 
  }
  // $lobbyDetails = getLobbyDataFromTableWithLobbyUser('lobbies','*',['lobbyID'=>$lobbyID,'isDisable'=>0],'',$userID);
  
             
}else{

  $insertUser=insertDataTable('lobbyusers',['userID'=>$userID,'lobbyID'=>$lobbyID,'isApproved'=>1, 'created'=>$updatedAt]);
  if($insertUser)
  {
    $getDetail=getuserDataFromTablebyId('lobbyusers','*',['id'=>$insertUser],'')[0];
    $getDetail['notificationType']=7;
    $lobbyDetails = getDataFromTable('lobbies','*',['lobbyID'=>$lobbyID],'')[0];
    $userDetails=getDataFromTable('users','*',['userID'=>$userID],'')[0];
    $notificationMessage = $userDetails['userName'];
    $message= "Sent joining request to you";
    $notificationUser = getDataFromTable('usertoken','*',['userID'=>$lobbyDetails['userID']],'');

    foreach ($notificationUser as $key1 => $valueUser) {
      if($valueUser['deviceType'] == 1) {
        $push_notification = sendpush_android($notificationMessage,$message, $valueUser['deviceToken'], $getDetail);
      }
      if($valueUser['deviceType'] == 2) {
        $push_notification = send_push_IOS_By_p8($notificationMessage,$message,$valueUser['deviceToken'],$getDetail,0);
      }
    }
    
    // $lobbyDetails = getLobbyDataFromTableWithLobbyUser('lobbies','*',['lobbyID'=>$lobbyID,'isDisable'=>0],'',$userID);
    http_response_code(200);
    $message =array('code'=>200,'status'=>1,'message'=>'Joining request sent successfully','data'=>$lobbyDetails);
    send_response($message);
    exit; 
             
  }else
  {
    http_response_code(400);
    $message =array('code'=>400,'status'=>0,'message'=>'something wents wrong');
    send_response($message);
    exit;
  }
}

?>