<?php
include 'Functions.php';

header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');

$data=json_decode(file_get_contents("php://input"),true);

$header = apache_request_headers(); 
if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
  send_response($message);
  exit;  

}


$userID=$TokenExist[0]['userID'];
// print_r($userID);
$otherUserID=$data['otherUserID'];
// print_r($otherUserID);
$commentID=$data['commentID'];
// print_r($commentID);
$created=time();

$userDetails=getDataFromTable('users','*',['userID'=>$userID],'')[0];
// print_r($userDetails);
$otherUserDetails=getDataFromTable('users','*',['userID'=>$otherUserID],'')[0];
// print_r($otherUserDetails);
$commentDetails=getDataFromTable('usercomments','*',['commentID'=>$commentID],'')[0];

$likeCommentExist=getDataFromTable('userlikecomments','*',['userID'=>$userID, 'otherUserID'=>$otherUserID, 'commentID'=>$commentID],'');
// print_r($likeCommentExist);
if(empty($likeCommentExist))
{

  $insert=insertDataTable('userlikecomments',['userID'=>$userID, 'otherUserID'=>$otherUserID, 'commentID'=>$commentID,'disable'=>0,'created'=>$created]);
  // print_r($insert);
  if($insert)
  {
    if($commentDetails['userID'] != $userID) {
      $notificationMessage = $userDetails['userName'];
      $message = "liked your comment.";
    
      $notificationData = insertDataTable('notification',['title'=>$notificationMessage,'description'=>$message,'notificationType'=>13,'userID'=>$commentDetails['userID'],'otherUserID'=>$userID,'detailsID'=>$otherUserID,'created'=>$created]);

      $where=['notificationID'=>$notificationData];
      $notificationDetails =getDataFromTable('notification','*',$where,'')[0];
      
      $notificationUser=getDataFromTable('usertoken','*',['userID'=>$notificationDetails['userID']],'');
      foreach ($notificationUser as $key1 => $valueUser) {
        if($valueUser['deviceType'] == 1) {
          $push_notification = sendpush_android($notificationMessage,$message, $valueUser['deviceToken'], $notificationDetails);
        }
        if($valueUser['deviceType'] == 2) {
          $push_notification = send_push_IOS_By_p8($notificationMessage,$message,$valueUser['deviceToken'],$notificationDetails,0);
        }
      }
    }

    http_response_code(200);
    $message =array('code'=>200,"status"=>1,"message"=>"Like Comment Successfully");
    send_response($message);
    exit; 

  }
  else
  {

    http_response_code(400);
    $message = array('code'=>400, "status" => 0, "message" => "Something went wrong". $con->error);
    send_response($message);
    exit;

  }

}else
{

  $delete = deleteDataTable('userlikecomments',['likeID'=>$likeCommentExist[0]['likeID']]);

  if($delete)
  {

    http_response_code(200);
    $message =array('code'=>200,"status"=>1,"message"=>"Dislike Comment Successfully");
    send_response($message);
    exit; 

  }

  else
  {

    http_response_code(400);
    $message = array('code'=>400, "status" => 0, "message" => "Something went wrong". $con->error);
    send_response($message);
    exit;

  }

}

?>