<?php
header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');
include 'Functions.php';
$data=json_decode(file_get_contents("php://input"),true);

$email=mysqli_real_escape_string($con,$_POST['email']);
$password=md5(mysqli_real_escape_string ($con,$_POST['password']));
$role=$_POST['role'];
$deviceToken=$_POST['deviceToken'];
$deviceType=$_POST['deviceType'];
$authToken=generateSalt(50);
$created=time();

if(!$email || !$password || !$role)
{

  http_response_code(400);
  $message = array('code'=>400, 'status'=>0,'message'=>"Parameters missing.");
  send_response($message);
  exit; 

}

$checkEmailExist=getDataFromTable('users','*',['email'=>$email,'role'=>$role],'');

if (empty($checkEmailExist)) 
{

  $checkEmailExist=getDataFromTable('users','*',['userName'=>$email,'role'=>$role],'');
  if(empty($checkEmailExist))
  {
    http_response_code(400);
    $message = array('code'=>400,"status"=>0,"message"=> "Username or email doesn't exist");
    send_response($message);
    exit; 
  } 

}
$check_login_email=getDataFromTable('users','*',['email'=>$email,'password'=>$password, 'role'=>$role, 'isDeleted'=>0],'');
if(!empty($check_login_email))
{
  $get_data=$check_login_email;
}else
{
  $get_data=getDataFromTable('users','*',['userName'=>$email,'password'=>$password, 'role'=>$role, 'isDeleted'=>0],'');
}


if(!empty($get_data))
{
  if($get_data[0]['disable']==1)
  {
    http_response_code(400);
    $message = array('code'=>400,"status"=>0,"message"=> "your account disabled, please contact to support.");
    send_response($message);
    exit; 
  }

  if($get_data[0]['verified']==0)
  {
    $messageStat = 'Your account not verified, please check your email and verify your account.';
    http_response_code(400);
    $message = array('code'=>400,'status'=>0,'message'=>$messageStat);
    send_response($message);
    exit;
  } 


  $current=strtotime(date('Y-m-d'));

  $where=['userID'=>$userID];
  $pagination=['LIMIT'=>'1'];
  $planDetail= getDataFromTableForPage('subscription','*',$where,'ORDER BY id DESC',$pagination);
  
  $newExpiry=$planDetail[0]['expireDate'];


if($current>=$newExpiry)
{
 
  $update_plan_date=updateDataTable('users',['userID'=>$get_data[0]['userID']],['isFreePlan'=>'1']);

}

  $get_venue_data=getDataFromTable('venue','*',['userID'=>$get_data[0]['userID'],'disable'=>0],'');
  if(!empty($get_venue_data))
  {
    $update= updateDataTable('users',['userID'=>$get_data[0]['userID']],['isAddVenue'=>1]);
  }

  $get_token_data=getDataFromTable('usertoken','*',['userID'=>$get_data[0]['userID']],'');
  if(!empty($get_token_data[0]['deviceToken']))
  {
    $delete=deleteDataTable('usertoken',['deviceToken'=>$get_token_data[0]['deviceToken']]);

    $insert=insertDataTable('usertoken',['userID'=>$get_data[0]['userID'],'deviceToken'=>$deviceToken,'deviceType'=>$deviceType,'authToken'=>$authToken,'created'=>$created ]);
  }else
  {
    $insert=insertDataTable('usertoken',['userID'=>$get_data[0]['userID'],'deviceToken'=>$deviceToken,'deviceType'=>$deviceType,'authToken'=>$authToken,'created'=>$created ]);
  }
            


     
  $userDetails=getUserData($get_data[0]['userID'],0,0);
  $userDetails['authToken']=$authToken;

  http_response_code(200); 
  $message =array('code'=>200,'status'=>1,'message'=>'Logged in Successfully','data'=>$userDetails);
  send_response($message);
  exit; 

}
else
{
  http_response_code(400);
  $message = array('code'=>400,"status"=>0,"message"=> "Incorrect password");
  send_response($message);
  exit; 

}

?>
