<?php

include 'Functions.php';


header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');
$data=json_decode(file_get_contents("php://input"),true);
$header = apache_request_headers(); 

if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
	http_response_code(401);
	$message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
	send_response($message);
	exit;  

}


$userID=$TokenExist[0]['userID'];
$type=$_POST['type'];    // 1=>Get My Event Listing, 2=>Get All Polular Events
$perpage = $_POST['perpage']?$_POST['perpage']:10; // get per page data limit
$pagenumber = $_POST['pagenumber']?$_POST['pagenumber']:1; //get page no
$offset = ($pagenumber - 1) * $perpage;

if($type==1)
{
	$getMyEventListing=getMyEventListing($userID,$type,$perpage,$offset);
}
if($type==2)
{
	$getMyEventListing=getMyEventListing(0,$type,$perpage,$offset);
}

if($type==1)
{
	$message='Get My Event Listing.';
}
if($type==2)
{
	$message='Get All Polular Events.';
}

if($getMyEventListing)
{
	http_response_code(200);
	$message = array('code'=>200,'status'=>1,'message'=>$message,'data'=>$getMyEventListing);
	send_response($message);
	exit;
}else
{
  http_response_code(400);
  $message = array('code'=>400,'status'=>0,'message'=>'No Listing','data'=>[]);
  send_response($message);
  exit;
}



?>