<?php
// ini_set('display_errors', '1');
// ini_set('display_startup_errors', '1');
// error_reporting(E_ALL);

include 'Functions.php';

header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');
$data=json_decode(file_get_contents("php://input"),true);
$header = apache_request_headers(); 

if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
	http_response_code(401);
	$message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
	send_response($message);
	exit;  

}

$userID=$TokenExist[0]['userID'];
$type=$_POST['type'];  // 1=>my venue listing, 2=>all venue listing, 3=>get all featured venue listing
$perpage = $_POST['perpage']?$_POST['perpage']:10; // get per page data limit
$pagenumber = $_POST['pagenumber']?$_POST['pagenumber']:1; //get page no
$offset = ($pagenumber - 1) * $perpage;

if($type==1)
{
	$getMyVenueListing=getMyVenueListing($userID,$type,$perpage,$offset);
}
if($type==2)
{
	$getMyVenueListing=getMyVenueListing(0,$type,$perpage,$offset);
}
if($type==3)
{
	$getMyVenueListing=getMyVenueListing(0,$type,$perpage,$offset);
}


if($type==1)
{
	$message='Get My Venue Listing.';
}
if($type==2)
{
	$message='Get All Venue Listing.';
}
if($type==3)
{
	$message='Get All Featured Venue.';
}


if($getMyVenueListing)
{
	http_response_code(200);
	$message = array('code'=>200,'status'=>1,'message'=>$message,'data'=>$getMyVenueListing);
	send_response($message);
	exit;
}else
{
  http_response_code(400);
  $message = array('code'=>400,'status'=>0,'message'=>'No Listing');
  send_response($message);
  exit;
}

?>