<?php
header('Content-Type: application/json');
header('Access-Control-Allow-Origin:*'); 
header('Access-Control-Allow-Methods: POST');

include 'Functions.php';
include_once('validateToken.php'); // if(empty($TokenExist)) Token is invalid
require_once('vendorStripe/autoload.php');

$userID = $TokenExist[0]['userID'];
$otherUserId = $_POST['otherUserId'];
$amount = $_POST['amount'];
$note = $_POST['note'];
$type = $_POST['type'];
$cardId = $_POST['cardId'];
$splitID = $_POST['splitID'];
$created = time();


if (!empty($splitID)) {
		// 0->success,1->pending,2->failed,3->request,4->reject request
	$getDetails = getDataFromTable('splitpayment','*',['splitID'=>$splitID,],'')[0];
	if (!empty($getDetails)) {
		if ($getDetails['status']=='0') {
			http_response_code(400);
			$message = array('code'=>400,'status'=>0,'message'=>"Payment already paid successfully.");
			send_response($message);
			exit; 
		}
		if ($getDetails['status']=='1') {
			http_response_code(400);
			$message = array('code'=>400,'status'=>0,'message'=>"Payment paid by you, pending to update in receiver account.");
			send_response($message);
			exit; 
		}
		
		if ($getDetails['status']=='4') {
			http_response_code(400);
			$message = array('code'=>400,'status'=>0,'message'=>"Payment rejected by you.");
			send_response($message);
			exit; 
		}
		
	}

}else{
	$getDetails = getDataFromTable('userpaid','*',['paidByUser'=>$userID,'otherUserID'=>$otherUserId],'')[0];
	if (!empty($getDetails)) {
		
		if ($getDetails['paymentStatus']=='0') {
			http_response_code(400);
			$message = array('code'=>400,'status'=>0,'message'=>"Payment already paid successfully.");
			send_response($message);
			exit; 
		}
		if ($getDetails['paymentStatus']=='1') {
			http_response_code(400);
			$message = array('code'=>400,'status'=>0,'message'=>"Payment paid by you, pending to update in receiver account.");
			send_response($message);
			exit; 
		}
			
	}

}

$where = ['userID'=>$otherUserId];
$existDetails = getDataFromTable('users','*',$where,'')[0];
if(empty($existDetails)){

	http_response_code(400);
	$message = array('code'=>400,'status'=>0,'message'=>"This user does not exist.");
	send_response($message);
	exit; 

}

$stripeAccountId = $existDetails['stripeAccountId'];

if(empty($stripeAccountId)){

	http_response_code(400);
	$message = array('code'=>400,'status'=>0,'message'=>"No account added.");
	send_response($message);
	exit; 
}

// Stripe Authentication 
$stripe = new \Stripe\StripeClient($stripe['secret_key']);



// $ddd=$stripe->accounts->update(
//   $stripeAccountId,
//   ['tos_acceptance' => ['service_agreement' => 'recipient']]
// );
// print_r($ddd);

// $account=$stripe->accounts->create([
//   'type' => 'custom',
//   'country' => 'US',
//   'email' => 'dharmaniz.abhishek@gmail.com',
//   'capabilities' => [
//     'card_payments' => ['requested' => true],
//     'transfers' => ['requested' => true],
//   ],
// ]);

// print_r($account['id']);

// $dataAccount= $stripe->accounts->createExternalAccount(
//   'acct_1032D82eZvKYlo2C',
//   [
//     'external_account' => 'btok_1NInbU2eZvKYlo2Cbmtt1OJB',
//   ]
// );

// print_r($dataAccount); 

// Transfer from client
try
{

	$stripe->transfers->create([
	  'amount' => $amount,
	  'currency' => 'USD',
	  'destination' => $stripeAccountId,
	  // 'transfer_group' => 'ORDER_95',
	]);

	// $cardCharges = $stripe->charges->create([
	//   'amount' => $amount,
	//   'currency' => 'GBP',
	//   'source' => $cardId,
	//   'customer'=> $customerId,
	//   'description' => $note,
	// ]);

	// echo json_encode($stripe);
	// exit();
}catch (\Stripe\Error\Base $e) {
	http_response_code(400);
  	// Code to do something with the $e exception object when an error occurs
  	$json = array('code'=>400,
  		'status'=>205,
   		'success' => 'error',
   		'paymentStatus'=>2,
   		'message'=>$e->getMessage()
   	);
   	echo json_encode($json);exit();
} catch (Exception $e) {
	http_response_code(400);
  	// Catch any other non-Stripe exceptions
  	$json = array('code'=>400,
  		'status'=>206,
   		'success' => 'error',
   		'paymentStatus'=>2,
   		'message'=>$e->getMessage()
   	);
  	echo json_encode($json);exit();
}

if(!empty($cardCharges['id'])){

	
	if (!empty($splitID)) {

  		$updated=updateDataTable('splitpayment',['splitID'=>$splitID],['cardPaidFrom'=>$cardId,'type'=>$type,'transactionID'=>$cardCharges['id'],'note'=>$note,'status'=>1,'updatedAt'=>time()]);


	}else{

	  	$inserted =insertDataTable('userpaid',['paidByUser'=>$userID,'cardPaidFrom'=>$cardId,'otherUserID'=>$otherUserId,'amount'=>$amount,'type'=>$type,'transactionID'=>$cardCharges['id'],'note'=>$note,'paymentStatus'=>1,'created'=>$created]);
	}




	http_response_code(200);
	$message = array('code'=>200,'status'=>1,'note'=>$note,'paymentStatus'=>1,'splitID'=>$splitID,'message'=>"Payment charge from card successfully",'transactionId'=>$cardCharges['id']);
	send_response($message);
	exit; 
}
