<?php
// ini_set('display_errors', 1);
// ini_set('display_startup_errors', 1);
// error_reporting(E_ALL);

header('Content-Type: application/json');
header('Access-Control-Allow-Origin:*'); 
header('Access-Control-Allow-Methods: POST');

include_once('Functions.php'); // function file
include_once('validateToken.php'); // if(empty($TokenExist)) Token is invalid

if(!isset($_POST['roomID']) || empty($_POST['roomID']) ){
  http_response_code(400);
  $message = array('code'=>400,'status'=>0,'message'=>"Parameter missing.");
  send_response($message);
  exit;
} 

$senderID = $TokenExist[0]['userID'];
$roomID = $_POST['roomID'];
$message = $_POST['message'];
$messageType = $_POST['messageType'];  // 1->text, 2->image, 3->image&text, 4->video, 5->video&text, 6->payment, 7-> split Payment
// $amount = $_POST['amount'];
$note = $_POST['note'];
$requestId = $_POST['requestId'];

$transactionID = $_POST['transactionID'];
$isPaymentStatus = $_POST['isPaymentStatus'];

$image = $_FILES['image']['name'];
$targetDir = "messageFiles/";
$created = time();

$getRoomData = getDataFromTable('chatrequest','*',['roomID'=>$roomID],'')[0];

if ($getRoomData['senderID']==$senderID) {
  $receiverID = $getRoomData['receiverID'];
}else{
  $receiverID = $getRoomData['senderID'];
}

if (!empty($_FILES['image']['name'][0]))
{
  if(!is_dir($targetDir))
  {
    mkdir($targetDir);
  }

  $filesCounter = $_FILES;
  $shareImage = [];
 
  for ($i=0; $i <count($_FILES['image']['name']) ; $i++) { 
    $fileName = uniqid().'_'.time().'.'.strtolower(pathinfo($_FILES['image']['name'][$i],PATHINFO_EXTENSION ));
    $targetFile = $targetDir . $fileName;
    if (move_uploaded_file($_FILES['image']["tmp_name"][$i], $targetFile)) {
      $shareImage[] = $targetFile;
    }else {
      http_response_code(400);
      $message = array('code'=>400,'status'=>0,'message'=>"Sorry, there was an error uploading your file.");
      send_response($message);
      exit; 
    }
  }

  $shareImage = implode( ",", $shareImage);
}
elseif(!empty($_POST['message'])){
  if(!empty($shareImage)){

    $shareImage = $shareImage;

  }else{

    $shareImage = "";

  }
}
else{

  http_response_code(400);
  $message = array('code'=>400,'status'=>0,'message'=>"Not sent empty messages.");
  send_response($message);
  exit; 

}

$data = ['roomID'=>$roomID,'senderID'=>$senderID,'receiverID'=>$receiverID,'message'=>$message,'messageType'=>$messageType,'messageFiles'=>$shareImage,'note'=>$note,'requestId'=>$requestId,'transactionID'=>$transactionID,'isPaymentStatus'=>$isPaymentStatus,'created'=>$created];
$insertMessage = insertDataTable('chatmessage',$data);
if($insertMessage) 
{
  $where = ['messageID'=>$insertMessage];
  $getMessageData = getMessageDataFromTableWithUserDetails('chatmessage','*',$where,$senderID,'')[0];
  if(!empty($getMessageData)){
    // 1->text, 2->image, 3->image&text, 4->video, 5->video&text, 6->payment, 7-> split Payment
    if ($messageType==2) {
      if(!empty($shareImage)){
        if(count(explode(',',$shareImage))>1){
          $message = " Sent ".count(explode(',',$shareImage))." images.";
        }else{
          $message = 'Sent a photo';
        }
      }
    }else if ($messageType==4) {
      if(count(explode(',',$shareImage))>1){
          $message = " Sent ".count(explode(',',$shareImage))." videos.";
        }else{
          $message = 'Sent a video';
        }
    }

    if($getRoomData['isGroup']==1){

        $where=['roomID'=>$roomID,'isDisable'=>0,'isAllowNotification'=>0];
        $GroupUsersDetails =getDataFromTable('chatgroupuser','*',$where,'');
        
        foreach ($GroupUsersDetails as $key => $value) {
          if ($messageType!=7) {
           
          if ($messageType==1) {
            $notificationMessage = "New message from ".$getMessageData['userName']. ' in "'.$getRoomData['groupName'] .'"';
            $notificationType = 3;
          }
          else if ($messageType==2) {
          $notificationMessage = "New message from ".$getMessageData['userName']. ' in "'.$getRoomData['groupName'] .'"';
          $notificationType = 3;
          }
          else if ($messageType==4) {
            $notificationMessage = "New message from ".$getMessageData['userName']. ' in "'.$getRoomData['groupName'] .'"';
            $notificationType = 3;
          }
          // else if ($messageType==7) {
          //   // $notificationMessage = "Split payment request from ".$getMessageData['userName']. ' in "'.$getRoomData['groupName'] .'"';
          //   $notificationMessage = "Split payment request in ".$getRoomData['groupName'] .'"';
          //   $message = "Pay to ".$getMessageData['userName'].' $'.$message;

          //   $notificationType = 5;
          // }
            // if(!empty($shareImage)){
            //   if(count(explode(',',$shareImage))>1){
            //     $message = " Sent ".count(explode(',',$shareImage))." images.";
            //   }else{
            //     $message = 'Sent a photo';
            //   }
            // }

            $notificationDetails =[
                'message' => $message,
                // 'receiverID' => $receiverID,
                'otherUserID' => $senderID,
                'created' => $created,
                'roomID'=>$roomID,
                'title'=> $notificationMessage,
                'userName'=>$getMessageData['userName'],
                // 'isGroup'=$getRoomData['isGroup'],
                // 'groupName'=$getRoomData['groupName'],
                'notificationType' => $notificationType
            ];

            if ($value['userID'] !=$senderID) {
                $notificationUser = getDataFromTable('usertoken','*',['userID'=>$value['userID']],'');
                foreach ($notificationUser as $key1 => $valueUser) {
                  if($valueUser['deviceType'] == 1) {
                    $notificationDetails['isGroup']=$getRoomData['isGroup'];
                    $notificationDetails['groupName']=$getRoomData['groupName'];
                    $push_notification = sendpush_android($notificationMessage,$message, $valueUser['deviceToken'], $notificationDetails);
                  }
                  if($valueUser['deviceType'] == 2) {
                    $notificationDetails['isGroup']=$getRoomData['isGroup'];
                    $notificationDetails['groupName']=$getRoomData['groupName'];
                    $push_notification = send_push_IOS_By_p8($notificationMessage,$message,$valueUser['deviceToken'],$notificationDetails,0);
                  }
                }
            }
          }
        }
    }

    if($receiverID > 0) {
        if ($messageType==1) {
          $notificationMessage = "New message from ".$getMessageData['userName'];
          $notificationType = 3;
        }
        else if ($messageType==2) {
          $notificationMessage = "New message from ".$getMessageData['userName'];
          $notificationType = 3;
        }
        else if ($messageType==4) {
          $notificationMessage = "New message from ".$getMessageData['userName'];
          $notificationType = 3;
        }
        else if ($messageType==6) {
            $userDetails = getDataFromTable('users','*',['userID'=>$senderID],'')[0];
            $notificationMessage = "Payment from ".$userDetails['userName'];
            $message ="$".$message;
            $notificationType = 4;
            
        }
        $notificationDetails =[
          'message' => $message,
          'receiverID' => $receiverID,
          'otherUserID' => $senderID,
          'created' => $created,
          'roomID'=>$roomID,
          'title'=> $notificationMessage,
          'userName'=>$userDetails['userName'],
          // 'isGroup'=$getRoomData['isGroup'],
          // 'groupName'=$getRoomData['groupName'],
          'notificationType' => $notificationType
        ];


        $notificationUser = getDataFromTable('usertoken','*',['userID'=>$notificationDetails['receiverID']],'');

        foreach ($notificationUser as $key1 => $valueUser) {
          if($valueUser['deviceType'] == 1) {
            $push_notification = sendpush_android($notificationMessage,$message, $valueUser['deviceToken'], $notificationDetails);
          }
          if($valueUser['deviceType'] == 2) {
            $push_notification = send_push_IOS_By_p8($notificationMessage,$message,$valueUser['deviceToken'],$notificationDetails,0);
          }
        }
    }


    http_response_code(200);
    $message = array('code'=>200,'status'=>1,'message'=>"Message sent successfully.",'data'=>$getMessageData);
    send_response($message);
    exit;
  }else{
    http_response_code(400);
    $message = array('code'=>400,'status'=>0,'message'=>"Failed to send messages ".mysqli_error($conn),'data'=>[]);
    send_response($message);
    exit; 
  }
}else{
  http_response_code(400);
  $message = array('code'=>400,'status'=>0,'message'=>"Failed to send messages ".mysqli_error($conn),'data'=>[]);
  send_response($message);
  exit; 
}


?>
