<?php
// ini_set('display_errors', '1');
// ini_set('display_startup_errors', '1');
// error_reporting(E_ALL);

include 'Functions.php';
header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');
$header = apache_request_headers(); 
if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
	http_response_code(401);
	$message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
	send_response($message);
	exit;  

}


$userID=$TokenExist[0]['userID'];
$eventId=$_POST['eventId']; // to check specific event tickets, if empty all tickets
$type=$_POST['type'];   // 1=>for host login, 2=>for user login, 
$perpage = $_POST['perpage']?$_POST['perpage']:10; // get per page data limit
$pagenumber = $_POST['pagenumber']?$_POST['pagenumber']:1; //get page no
$offset = ($pagenumber - 1) * $perpage;


$ticketHistoryListing=ticketHistoryListing($userID,$type,$perpage,$offset,$eventId);
if($ticketHistoryListing)
{
	http_response_code(200);
    $message = array('code'=>200,'status'=>1,'message'=>"Get ticket history listing",'data'=>$ticketHistoryListing);
    send_response($message);
    exit;
}else
{
	http_response_code(400);
    $message = array('code'=>400,'status'=>0,'message'=>"No data found",'data'=>[]);
    send_response($message);
    exit;
}

function ticketHistoryListing($userID,$type,$perpage,$offset,$eventId)
{
	global $con;
	global $config;
	$array=array();
	
	if($eventId){
	
		if($type==1)
		{
			$query="SELECT * FROM eventvenuebooking WHERE bookingUserID=$userID AND eventId=$eventId AND isPurchased=1 AND disable=0 ORDER BY startDateAndTime ASC LIMIT $perpage OFFSET $offset";
		}
		if($type==2)
		{

			$query="SELECT * FROM eventvenuebooking WHERE hostUserID=$userID AND eventId=$eventId AND isPurchased=1 AND disable=0 ORDER BY startDateAndTime ASC  LIMIT $perpage OFFSET $offset";
		}
	
	
	}else{
	
		if($type==1)
		{
			$query="SELECT * FROM eventvenuebooking WHERE bookingUserID=$userID AND isPurchased=1 AND disable=0 ORDER BY startDateAndTime ASC LIMIT $perpage OFFSET $offset";
			// print_r($query);
		}
		if($type==2)
		{

			$query="SELECT * FROM eventvenuebooking WHERE hostUserID=$userID AND isPurchased=1 AND disable=0 ORDER BY startDateAndTime ASC  LIMIT $perpage OFFSET $offset";
		}
	}
	// print_r($query);die();
	$run = $con->query($query);
	while($result = $run->fetch_assoc())
	{

		$venueName = getDataFromTable('venue','*',['venueID'=>$result['venueID']],'')[0];
		if($venueName)
		{
			$result['venueName']=$venueName['venueName'];
		}else
		{
			$result['venueName']="";
		}

		$result['venueAddress']=$venueName['venueAddress'];

		if(!empty($result['eventID']))
		{


			$eventName = getDataFromTable('event','*',['eventID'=>$result['eventID']],'')[0];
			if($eventName)
			{
				$result['eventName']=$eventName['eventName'];
			}else
			{
				$result['eventName']="";
			}

			$result['eventAddress']=$eventName['location'];

			if (!empty($eventName['eventImage'])) {
         

		      $result['eventImage']=$config['base_url'].$eventName['eventImage'];


		      }
		      else
		      {
		          $result['eventImage']="";
		      }
		}else
		{
			$result['eventName']="";
			$result['eventImage']="";
			$result['eventAddress']="";
		}

		$userDetail = getDataFromTableWithImages('users','userID,firstName,lastName,userName',['userID'=>$result['bookingUserID']],'');
		// print_r($userDetail);
		$result['firstName']=$userDetail[0]['firstName'];
		$result['lastName']=$userDetail[0]['lastName'];
		$result['userName']=$userDetail[0]['userName'];

		$venueImg=getVenueImages($result['venueID'],"0");
      
		if($venueImg)
		{
			$result['venueImg']=$venueImg;
		}else
		{
			$result['venueImg']=[];
		}
		array_push($array, $result);
	}
	return $array;
}

?>
