<?php
include 'Functions.php';

header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');

$data=json_decode(file_get_contents("php://input"),true);

$header = apache_request_headers(); 

if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
  send_response($message);
  exit;  

}


$userID=$TokenExist[0]['userID'];
$id=$data['id'];
$type = $data['type'];
$perpage=$data['perpage'];
$pagenumber=$data['pagenumber'];
$offset=($pagenumber-1)*$perpage;
if ($type ==1) {
  $getData=getDataFromTable('users','*',['userID'=>$id],'')[0];
  // $commentsListing=getUserCommentsListingV2($id);
  $commentsListing=getUserCommentsListing($id,$userID,$perpage,$offset);
}elseif ($type==2) {
  // $commentsListing=getEventCommentsListingV2($id);
  $commentsListing=getEventCommentsListing($id,$userID,$perpage,$offset);
}else{
  http_response_code(400);
  $message =array('code'=>400,'status'=>0,'message'=>'Enter valid type');
  send_response($message);
  exit; 

}

if ($type ==1) {
    $getData=getDataFromTableWithImages('users','*',['userID'=>$id],'')[0];
    // print_r($getData);
    $getRatingData=getDataFromTable('userrating','*',['userID'=>$userID, 'ratingToOtherID'=>$id],'')[0];
    if (!empty($getRatingData)) {

      $isRatingType = "1";
    }else{

      $isRatingType = "0";
    }
    $userName = $getData['userName'];
    $Address = $getData['address'];
    $country = $getData['country'];
    $state = $getData['state'];
    $city = $getData['city'];
    $profileImage = $getData['profileImage'];
  }else{
    $userName = null;
    $Address = null;
    $country = null;
    $state = null;
    $city = null;
    $profileImage = null;
    $isRatingType = null;
  }

if($commentsListing)
{
  

  http_response_code(200);
  $message =array('code'=>200,'status'=>1,'userName'=>$userName,'profileImage'=>$profileImage,'isRatingType'=>$isRatingType,'message'=>'Get Comments Listing','data'=>$commentsListing);
  send_response($message);
}
else
{
  http_response_code(200);
  $message =array('code'=>200,'status'=>1,'userName'=>$userName,'profileImage'=>$profileImage,'isRatingType'=>$isRatingType,'message'=>'No Listing','data'=>$commentsListing);
  send_response($message);
  exit; 
}

?>