<?php
include 'Functions.php';
header('content-type:application/json');
header('access-control-allow-origin:*');
header('access-control-allow-method:POST');

$header = apache_request_headers(); 
if(!isset($header['Token']) || empty($header['Token']))
{
  http_response_code(401);
  $message = array('code'=>401,'status'=>401,'message'=>"Token is missing.");
  send_response($message);
  exit;

}

$token = $header['Token'];

$TokenExist = getDataFromTable('usertoken','*',['authToken'=>$token],'');
if(empty($TokenExist))
{
	http_response_code(401);
	$message = array('code'=>401,'status'=>401,'message'=>"Token is not valid");
	send_response($message);
	exit;  

}


$userID=$TokenExist[0]['userID'];
$venueID=$_POST['venueID'];
$search=$_POST['search'];
$perpage = $_POST['perpage']?$_POST['perpage']:10; // get per page data limit
$pagenumber = $_POST['pagenumber']?$_POST['pagenumber']:1; //get page no
$offset = ($pagenumber - 1) * $perpage;

$venueDetailAndEventListing=venueDetailAndEventListing($venueID,$search,$perpage,$offset)[0];
if($venueDetailAndEventListing)
{
	http_response_code(200);
    $message = array('code'=>200,'status'=>1,'message'=>"Get Venue Detail And Event Listing",'data'=>$venueDetailAndEventListing);
    send_response($message);
    exit;
}else
{
	http_response_code(400);
    $message = array('code'=>400,'status'=>0,'message'=>"No data found",'data'=>[]);
    send_response($message);
    exit;
}

function venueDetailAndEventListing($venueID,$search,$perpage,$offset)
{
	global $con;
	global $config;
	$array=array();


	$query="SELECT venueID,venueName,categoryID,userID,layoutImage,parkingImage,description FROM venue WHERE venueID=$venueID AND disable=0 ";
	// print_r($query);die();
	$run = $con->query($query);
	while($result = $run->fetch_assoc())
	{
		$geTicketCategory=getDataFromTableWithImages('venueticketcategory','*',['venueID'=>$venueID,'categoryID'=>$result['categoryID'],'disable'=>0],'')[0];
		// print_r($geTicketCategory['venueTicketCatId']);die();
		if($result['categoryID']==4)
		{

		$getEventTicketData =getDataFromTableWithImages('venuetickets','*',['venueID'=>$venueID,'categoryID'=>$result['categoryID'],'ticketCatId'=>0],'')[0];
		}else
		{
			$getEventTicketData =getDataFromTableWithImages('venuetickets','*',['venueID'=>$venueID,'categoryID'=>$result['categoryID'],'ticketCatId'=>$geTicketCategory['venueTicketCatId']],'')[0];
		}

		if (!empty($getEventTicketData)) {
		   $result['ticketPrice']=$getEventTicketData['ticketPrice'];
		}else{
		   $result['ticketPrice']="";
		}

		if (!empty($result['layoutImage'])) {
         
	      $result['layoutImage']=$config['base_url'].'venue/layoutImage/'.$result['layoutImage'];
	    }
	    else
	    {
	        $result['layoutImage']="";
	    }

	    if (!empty($result['parkingImage'])) {
         
	      $result['parkingImage']=$config['base_url'].'venue/barCodeImage/'.$result['parkingImage'];
	    }
	    else
	    {
	        $result['parkingImage']="";
	    }

		$venueImg=getVenueImages($result['venueID'],"0");
      
		if($venueImg)
		{
			$result['venueImg']=$venueImg;
		}else
		{
			$result['venueImg']=[];
		}
		
		$eventListingByVenue=eventListingByVenue($venueID,$search,$perpage,$offset);
		$result['eventListing']=$eventListingByVenue;
		array_push($array, $result);
	}

	return $array;
}

function eventListingByVenue($venueID,$search,$perpage,$offset)
{
	global $con;
	global $config;
	$array=array();

	$query="SELECT event.* FROM event
	INNER JOIN eventvenuebooking ON event.eventID = eventvenuebooking.eventID
	 WHERE event.venueID=$venueID AND event.eventName LIKE '%$search%' AND event.disable=0 GROUP BY event.eventID LIMIT $perpage OFFSET $offset";


	// $query="SELECT userID,eventID,venueID,eventName,eventDescription,eventImage,eventCost,parkingCost,startDate,startTime,endDate,endTime,startDateAndTime,endDateAndTime,created FROM event WHERE venueID=$venueID AND eventName LIKE '%$search%' AND disable=0 LIMIT $perpage OFFSET $offset";
	// print_r($query);die();
	$run = $con->query($query);
	while($result = $run->fetch_assoc())
	{
		if (!empty($result['eventImage'])) {        

      		$result['eventImage']=$config['base_url'].$result['eventImage'];
      	}else{       
        
        	$result['eventImage']="";
        }
		array_push($array, $result);
	}

	return $array;
}

?>